#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.10.2
 Author:         Kanashius
 Rights:		 Alle Rechte sind der Person hinter dem Nickname Kanashius im Autoit.de Forum vorbehalten.
				 Die Verbreitung ist kommerziell verboten und darf nur kostenlos erfolgen.
				 Das Programm und der Quelltext drfen auch nur solange verbreitet werden, wie der Autor es erlaubt.
				 Der Quelltext darf (in Ausschnitten und als Ganzes) nur mit Nennung des Autors verbreitet werden.
 Script Function:
				 Programm um E-Pubs zu verwalten. Dabei wurde besonders auf Geschwindigkeit Wertgelegt.

#ce ----------------------------------------------------------------------------

#include <array.au3>
#include <SQLite.au3>
#include <SQLite.dll.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <GuiListView.au3>
#include <GuiListBox.au3>
#include <GUIConstants.au3>
#include <File.au3>
#include <WinAPI.au3>
#include <GDIPlus.au3>
#include <ComboConstants.au3>
#include <ProgressConstants.au3>
#include <String.au3>
#include <HTML.au3>
#include <IE.au3>
#include "MouseOnEvent.au3"

Opt("GUIOnEventMode", 1)
Opt("TrayMenuMode", BitOR(1,2))
Opt("TrayOnEventMode", 1)
AutoItSetOption("MouseCoordMode", 1)

;HotKeySet("{1}","gibPos")	;Test Funktion
;`ID` INTERGER,`Identifier` TEXT,`author` TEXT,`description` TEXT,`title` TEXT,`subject` TEXT,`date` TEXT,`path` TEXT,`language` TEXT,`rating` TEXT

global $iClumn, $iRow,$aData ;Globale Variablen, in die das Ergebnis einer SQL-Abfrage gespeichert wird
global $guiInfo[5],$loadAtBegin=false,$loadGenreCount=false
global $WaitLabel,$WaitLabel_Progress
global $ImportGui,$ImportLabel,$ImportProgressBar,$ImportInterrupt,$import_abbrechen=false,$UnZipTime=0
global $GuiChangeData,$GuiChangeData_InputTitle,$GuiChangeData_InputAutor,$GuiChangeData_InputGenre,$GuiChangeData_InputID,$GuiChangeData_InputDate,$GuiChangeData_InputLang,$GuiChangeData_EditDesc,$GuiChangeData_ButtonPfad,$changeDataID,$selected,$GuiChangeData_Combo
global $settingsGui,$settingsGui_Radio1,$settingsGui_Radio2,$settingsGui_Radio3,$settingsGui_Radio4
Global $pos1 = MouseGetPos(),$pos2 = MouseGetPos(),$appHandle = 0,$mouseDown=false
global $ExtractFails="",$isInDB=""
global $GenreSettingsIniPath="GenreSettings.ini"
global $GenreSettingsGui,$GenreSettingsGui_ListView1,$GenreSettingsGui_Input1,$GenreSettingsGui_Input2
global $SqlGui,$SqlGui_handle,$SqlGui_size,$SqlGui_Edit3_1,$SqlGui_ListView3_1,$SqlGui_Button3_1,$SqlGui_Button3_2
global $GuiRate,$GuiRateChangeDataID,$GuiRate_Combo

$settingsIniPfad=@ScriptDir&"\settings.ini"
If FileExists($settingsIniPfad)=0 Then
	;settings.ini erstellen
	$settingsFile=FileOpen($settingsIniPfad)
	$string="PosX=0"&@LF&"PosY=0"&@LF&"Width="&@DesktopWidth&@LF&"Height="&@DesktopHeight&@LF&"State=47"
	IniWriteSection($settingsIniPfad,"GuiSettings",$string)
	$string="LoadAllAtBegin=true"&@LF&"LoadGenreCounts=true"&@LF
	IniWriteSection($settingsIniPfad,"General",$string)
	FileClose($settingsFile)
EndIf

If FileExists($GenreSettingsIniPath)=0 Then
	;GenreSettings.ini erstellen
	FileClose(FileOpen($GenreSettingsIniPath))
EndIf

$guiInfo[0]=IniRead($settingsIniPfad,"GuiSettings","PosX","0")
$guiInfo[1]=IniRead($settingsIniPfad,"GuiSettings","PosY","0")
$guiInfo[2]=IniRead($settingsIniPfad,"GuiSettings","Width",@DesktopWidth)
$guiInfo[3]=IniRead($settingsIniPfad,"GuiSettings","Height",@DesktopHeight)
$guiInfo[4]=IniRead($settingsIniPfad,"GuiSettings","State","47")
if IniRead($settingsIniPfad,"General","LoadAllAtBegin","true")="true" then
	$loadAtBegin=true
else
	$loadAtBegin=false
endif
if IniRead($settingsIniPfad,"General","LoadGenreCounts","true")="true" then
	$loadGenreCount=true
else
	$loadGenreCount=false
endif

_SQLite_Startup();sqlite starten
$hDatabase = _SQLite_Open(@ScriptDir & "\Buecher.sqlite") ;Datenbank ffnen
_SQLite_Exec($hDatabase, "CREATE TABLE IF NOT EXISTS `Buecher`(`ID` INTERGER,`Identifier` TEXT,`author` TEXT,`description` TEXT,`subject` TEXT,`title` TEXT,`date` TEXT,`path` TEXT,`language` TEXT,`rating` TEXT)")
if @error then
	msgbox(48,"",@error)
EndIf
;TraySetIcon("", -1)
;TraySetClick("16")
;$MainGui_Tray1 = TrayCreateItem("Verstecken")
$MainGui_Tray2 = TrayCreateItem("Beenden")
TrayItemSetOnEvent($MainGui_Tray2, "MainGui_Close")

;Hauptfenster
$MainGui = GUICreate("Bcherverwaltung", $guiInfo[2], $guiInfo[3]-25, $guiInfo[0], $guiInfo[1],$WS_CAPTION +$WS_SYSMENU+ $WS_SIZEBOX +$WS_MINIMIZEBOX+$WS_MAXIMIZEBOX,$WS_EX_ACCEPTFILES)
$MainGuiMenu1 = GUICtrlCreateMenu("Datei")
$MainGuiMenu1_1 = GUICtrlCreateMenuItem("Importiere Ordner", $MainGuiMenu1)
GUICtrlSetOnEvent(-1,"ImportFolder")
$MainGuiMenu1_1 = GUICtrlCreateMenuItem("Sql Konsole (Vorsichtig benutzen!)", $MainGuiMenu1)
GUICtrlSetOnEvent(-1,"sqlkonsole")
;$MainGuiMenu1_2 = GUICtrlCreateMenuItem("Lesen", $MainGuiMenu1)
;GUICtrlSetOnEvent(-1,"Reader")
$MainGuiMenu2 = GUICtrlCreateMenu("Bearbeiten")
$MainGuiMenu2_1 = GUICtrlCreateMenuItem("Alle Bcher aus der Datenbank entfernen", $MainGuiMenu2)
GUICtrlSetOnEvent(-1,"deleteAllBooks")
$MainGuiMenu3 = GUICtrlCreateMenu("Einstellungen")
$MainGuiMenu3_1 = GUICtrlCreateMenuItem("Einstellungen", $MainGuiMenu3)
GUICtrlSetOnEvent(-1,"settings")
$MainGuiMenu3_2 = GUICtrlCreateMenuItem("Genre Optionen", $MainGuiMenu3)
GUICtrlSetOnEvent(-1,"_genreSettings")
$MainGui_handle = wingethandle($MainGui)
$MainGui_size=WinGetClientSize($MainGui_handle)

;Hauptfenster
$MainGui_GroupMain = GUICtrlCreateGroup("", 200, 5, $MainGui_size[0]-500, $MainGui_size[1]-20)
GUICtrlSetResizing ( -1, 102 )
$MainGui_Input1=GUICtrlCreateInput("",200,15,150,20)
GUICtrlSetResizing ( -1, 768+2)
$MainGui_Combo1 = GUICtrlCreateCombo("Alle", 360, 15, 150, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetResizing ( -1, 768+2)
$MainGui_Combo2 = GUICtrlCreateCombo("hnlich", 520, 15, 150, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL))
GUICtrlSetData($MainGui_Combo2,"Gleich")
GUICtrlSetResizing ( -1, 768+2)
$MainGui_Button1=GUICtrlCreateButton("Suchen",680,15,50,20)
GUICtrlSetOnEvent(-1,"search")
GUICtrlSetResizing ( -1, 768+2)
$MainGui_MainListView = GUICtrlCreateListView("", 200, 40, $MainGui_size[0]-500, $MainGui_size[1]-85)
GUICtrlSetResizing ( -1, 102 )
GUICtrlSetState(-1,$GUI_DROPACCEPTED)
$ListViewSize=ControlGetPos($MainGui,"",$MainGui_MainListView)
$ListViewMenu = GUICtrlCreateContextMenu($MainGui_MainListView)
$ListViewMenuItem1 = GUICtrlCreateMenuItem("ffnen", $ListViewMenu)
GUICtrlSetOnEvent(-1, "openBook")
$ListViewMenuItem2 = GUICtrlCreateMenuItem("Kopiere Pfad in Zwischenablage", $ListViewMenu)
GUICtrlSetOnEvent(-1, "copyPath")
$ListViewMenuItem3 = GUICtrlCreateMenuItem("ffne den Ordner, der das Buch enthlt!", $ListViewMenu)
GUICtrlSetOnEvent(-1, "openBookFolder")
$ListViewMenuItem4 = GUICtrlCreateMenuItem("Bearbeiten", $ListViewMenu)
GUICtrlSetOnEvent(-1, "changeData")
$ListViewMenuItem5 = GUICtrlCreateMenuItem("Lsche das Buch aus Datenbank", $ListViewMenu)
GUICtrlSetOnEvent(-1, "deleteBook")
$ListViewMenuItem6 = GUICtrlCreateMenuItem("Entferne das Buch vom Computer", $ListViewMenu)
GUICtrlSetOnEvent(-1, "deleteBookReal")
$WaitLabel=GUICtrlCreateLabel("Bitte warten Sie!"&@crlf&"Die Daten werden aus der Datenbank abgerufen!", $ListViewSize[0]+$ListViewSize[2]/2-50,$ListViewSize[1]+$ListViewSize[3]/2-25,100,55)
GUICtrlSetResizing ( -1, bitor(768,0))
$MainGui_MainListView_CountLabel=GUICtrlCreateLabel("Eintrge in der Liste: 0", 200, 40+$MainGui_size[1]-80, $MainGui_size[0]-500, 20)
GUICtrlSetResizing ( -1, bitor(768,0))
$WaitLabel_Progress=GUICtrlCreateProgress($ListViewSize[0]+$ListViewSize[2]/2-200,$ListViewSize[1]+$ListViewSize[3]/2-25+70,400,50)
GUICtrlSetResizing ( -1, bitor(768,0))
$ProgressLabel=GUICtrlCreateLabel("Abgerufene Datenstze: ", $ListViewSize[0]+$ListViewSize[2]/2-100,$ListViewSize[1]+$ListViewSize[3]/2-25+70,400,50)
GUICtrlSetResizing ( -1, bitor(768,0))
$ProgressLabel1=GUICtrlCreateLabel("0", $ListViewSize[0]+$ListViewSize[2]/2+20,$ListViewSize[1]+$ListViewSize[3]/2-25+70,400,50)
GUICtrlSetResizing ( -1, bitor(768,0))
GUICtrlSetState($WaitLabel,$GUI_HIDE)
GUICtrlSetState($ProgressLabel,$GUI_HIDE)
GUICtrlSetState($ProgressLabel1,$GUI_HIDE)
GUICtrlSetState($WaitLabel_Progress,$GUI_HIDE)
;Recht Gruppe (Anzeigen der Infos eines Buches)
$MainGui_GroupRight = GUICtrlCreateGroup("", 200+$MainGui_size[0]-500, 5, 290, $MainGui_size[1]-20)
GUICtrlSetResizing ( -1, 256)
GUICtrlCreateLabel("Buchname:",200+$MainGui_size[0]-500+10,65,60,28)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Autor:",200+$MainGui_size[0]-500+10,95,60,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Genre:",200+$MainGui_size[0]-500+10,115,60,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Ident. NR.:",200+$MainGui_size[0]-500+10,135,60,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Erstelldatum:",200+$MainGui_size[0]-500+10,165,60,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Sprache:",200+$MainGui_size[0]-500+10,185,60,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Dateiname:",200+$MainGui_size[0]-500+10,205,60,38)
GUICtrlSetResizing ( -1, bitor(768,4,32))
GUICtrlCreateLabel("Pfad:",200+$MainGui_size[0]-500+10,235,60,58)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_Rating=GUICtrlCreatePic("",200+$MainGui_size[0]-500+40,15,227,45)
GUICtrlSetOnEvent(-1,"RateBook")
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_Bookname=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,65,200,28)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_BookAuthor=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,95,200,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_BookGenre=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,115,200,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_BookIdentifier=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,135,200,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_BookDate=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,165,200,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_BookLanguage=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,185,200,18)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_DataName=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,205,200,38)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_GroupRight_Path=GUICtrlCreateLabel("",200+$MainGui_size[0]-500+70,235,200,58)
GUICtrlSetResizing ( -1, bitor(768,4,32))
$MainGui_IE = _IECreateEmbedded ()
$MainGui_GroupRight_Description = GUICtrlCreateObj($MainGui_IE,200+$MainGui_size[0]-500+15,300,270,$MainGui_size[1]-20-320)
_IENavigate($MainGui_IE, 'about:blank')
;$MainGui_GroupRight_Description=GUICtrlCreateEdit("",200+$MainGui_size[0]-500+15,300,270,$MainGui_size[1]-20-210,$ES_WANTRETURN+$WS_VSCROLL);+$ES_READONLY)
GUICtrlSetResizing ( -1, bitor(4,32,64,256))
;_sendmessage(ControlGetHandle("Bcherverwaltung","",$MainGui_GroupRight_Description),$EM_SETREADONLY,1)

;$MainGui_GroupRight_Cover=
;linke Gruppe (auswahl der Kategorie)
$MainGui_GroupRight = GUICtrlCreateGroup("", 10, 5, 190, $MainGui_size[1]-20)
GUICtrlSetResizing ( -1, 256)
#cs
;-------------------------------------------------------------------------------------------------------------------Alte Genres erkennung
MainGetData("Select subject,count(id) from Buecher where 1 group by subject")
$string=""
for $i=$iClumn+1 to UBound($aData)-1 step 2
	if $aData<>"" then
		;$string&=$aData[$i]&" - ("&$aData[$i+1]&")|"
		$string&=$aData[$i]&@crlf
	endif
next
ClipPut($string)
;-------------------------------------------------------------------------------------------------------------------Alte Genres erkennung(ende)
#ce
$MainGui_ListBox1 = GUICtrlCreateList("", 15, 15, 170, $MainGui_size[1]-40,BitOR($LBS_SORT, $WS_BORDER, $WS_VSCROLL, $LBS_NOTIFY, $LBS_MULTIPLESEL))
GUICtrlSetResizing ( -1, 256)
$MainGui_MainhListView_Handle = wingethandle(-1)

;allgemeine Einstellungen
GUICtrlCreateGroup("", -1, -1, 1, 1)

GUISetOnEvent($GUI_EVENT_CLOSE, "MainGui_Close")
GUISetOnEvent($GUI_EVENT_MINIMIZE, "MainGuu_Minimize")
GUISetOnEvent($GUI_EVENT_MAXIMIZE, "MainGui_Maximize")
if $guiInfo[4]="47" then
	GUISetState(@SW_MAXIMIZE,$MainGui)
endif
GUISetState(@SW_SHOW,$MainGui)

GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")
GUIRegisterMsg($WM_DROPFILES, 'WM_DROPFILES_FUNC')
;_MouseSetOnEvent($MOUSE_PRIMARYUP_EVENT, "_MouseUp")
;_MouseSetOnEvent($MOUSE_PRIMARYDOWN_EVENT, "_MouseDown")

MainGetData("Select * from Buecher where id=0")
$string=""
if $iClumn>0 then
	$string&=$aData[1]
	for $i=2 to $iClumn step 1
		if $aData<>"" then
			$string&="|"&$aData[$i]
		endif
	next
endif
GUICtrlSetData($MainGui_Combo1,""&$string)

setGenre()

if $loadAtBegin then
	getDataAndFillListview("Select id as ID,title as Name,author as Autor,subject,path as Genre from Buecher where 1 ORDER BY title ASC",true)
endif

;Main Schleife
while 1
	sleep(100)
WEnd

;Functions---------------------------------------------------------------------------------------------------
Func deleteAllBooks()
	if msgbox(4,"Speichern","Mchten sie wirklich alle Bcher aus der Datenbank entfernen?")=6 then
		_SQLite_Close($hDatabase)
		FileDelete(@ScriptDir & "\Buecher.sqlite")
		$hDatabase = _SQLite_Open(@ScriptDir & "\Buecher.sqlite")
		_SQLite_Exec($hDatabase, "CREATE TABLE IF NOT EXISTS `Buecher`(`ID` INTERGER,`Identifier` TEXT,`author` TEXT,`description` TEXT,`subject` TEXT,`title` TEXT,`date` TEXT,`path` TEXT,`language` TEXT)")
		setGenre()
		if $loadAtBegin then
			getDataAndFillListview("Select id as ID,title as Name,author as Autor,subject,path as Genre from Buecher where 1 ORDER BY title ASC",true)
		endif
		msgbox(48,"Erfolg","Die Bcher wurden erfolgreich aus der Datenbank entfernt!")
	endif
EndFunc

Func deleteBook()
	$sel=_GUICtrlListView_GetSelectedIndices (GUICtrlGetHandle($MainGui_MainListView))

	if $sel<>"" then
		$name=MainGetDataRet("Select title from Buecher where id='"&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$sel,0))&"'")[2]
		if msgbox(4,"Speichern",'Mchten sie das Buch "'&$name&'" wirklich aus der Datenbank entfernen?')=6 then
			_SQLite_Exec($hDatabase,"DELETE FROM Buecher WHERE id='"&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$sel,0))&"'")
			setGenre()
			_GUICtrlListView_DeleteItem($MainGui_MainListView,$sel)
			msgbox(48,"Erfolg",'Das Buch "'&$name&'" wurde erfolgreich aus der Datenbank entfernt!')
		endif
	endif
EndFunc

Func deleteBookReal()
	$sel=_GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($MainGui_MainListView))
	if $sel<>"" then
		$name=MainGetDataRet("Select title from Buecher where id='"&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$sel,0))&"'")[2]
		$path=MainGetDataRet("Select path from Buecher where id='"&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$sel,0))&"'")[2]
		if StringSplit($path,"")[1]="\" then
			$path=@ScriptDir&$path
		endif
		if msgbox(4,"Speichern",'Mchten sie das Buch "'&$name&'" wirklich vollstndig von ihrem Computer entfernen?')=6 then
			_SQLite_Exec($hDatabase,"DELETE FROM Buecher WHERE id='"&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$sel,0))&"'")
			setGenre()
			_GUICtrlListView_DeleteItem($MainGui_MainListView,$sel)
			FileDelete($path)
			msgbox(48,"Erfolg",'Das Buch "'&$name&'" wurde erfolgreich vom Computer entfernt!')
		endif
	endif
EndFunc

Func setGenre()
	GUISetState(@SW_DISABLE,$MainGui)
	_MouseSetOnEvent($MOUSE_PRIMARYUP_EVENT, "")
	_MouseSetOnEvent($MOUSE_PRIMARYDOWN_EVENT, "")
	_GUICtrlListBox_ResetContent($MainGui_ListBox1)
	;search for genres
	GUICtrlSetData($WaitLabel,"Bitte warten Sie!"&@crlf&"Die Genres werden aus der Datenbank abgerufen!")
	GUICtrlSetData($WaitLabel_Progress,0)
	GUICtrlSetState($MainGui_MainListView,$GUI_DISABLE)
	GUICtrlSetState($MainGui_ListBox1,$GUI_DISABLE)
	GUICtrlSetState($MainGui_MainListView,$GUI_HIDE)
	GUICtrlSetState($WaitLabel,$GUI_SHOW)
	GUICtrlSetState($WaitLabel_Progress,$GUI_SHOW)
	GUICtrlSetState($MainGui_Button1,$GUI_DISABLE)
	$string=""
	$ar=FileReadToArray($GenreSettingsIniPath)
	for $i=1 to UBound($ar)-1 step 1
		if $loadGenreCount then
			$string&=stringsplit($ar[$i],"=")[1]&" - ("&MainGetDataRet("Select count(id) from Buecher where "&IniRead($GenreSettingsIniPath,"Genres",stringsplit($ar[$i],"=")[1],-1))[2]&")|"
		else
			$string&=stringsplit($ar[$i],"=")[1]&" - (?)|"
		endif
		GUICtrlSetData($WaitLabel_Progress,$i/(Ubound($ar)/100))
	next
	GUICtrlSetData($WaitLabel_Progress,0)
	GUICtrlSetState($MainGui_MainListView,$GUI_ENABLE)
	GUICtrlSetState($MainGui_ListBox1,$GUI_ENABLE)
	GUICtrlSetState($MainGui_MainListView,$GUI_SHOW)
	GUICtrlSetState($WaitLabel,$GUI_HIDe)
	GUICtrlSetState($WaitLabel_Progress,$GUI_HIDE)
	GUICtrlSetState($MainGui_Button1,$GUI_ENABLE)
	GUICtrlSetData($MainGui_ListBox1,$string&"Alle")
	_MouseSetOnEvent($MOUSE_PRIMARYUP_EVENT, "_MouseUp")
	_MouseSetOnEvent($MOUSE_PRIMARYDOWN_EVENT, "_MouseDown")
	;search for genres END
	GUISetState(@SW_ENABLE,$MainGui)
EndFunc

Func settings()
	$settingsGui=GUICreate("Einstellungen", 215, 168, -1,-1)
	$settingsGui_Group1 = GUICtrlCreateGroup("Alle Bcher beim Start auflisten?", 8, 8, 201, 57)
	$settingsGui_Radio1 = GUICtrlCreateRadio("Ja", 24, 24, 113, 17)
	$settingsGui_Radio2 = GUICtrlCreateRadio("Nein", 24, 40, 113, 17)
	if $loadAtBegin then
		GUICtrlSetState($settingsGui_Radio1, $GUI_CHECKED)
	else
		GUICtrlSetState($settingsGui_Radio2, $GUI_CHECKED)
	endif
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$settingsGui_Group2 = GUICtrlCreateGroup("Azahl der Bcher pro Genre anzeigen?", 8, 72, 201, 57)
	$settingsGui_Radio3 = GUICtrlCreateRadio("Ja", 24, 88, 113, 17)
	$settingsGui_Radio4 = GUICtrlCreateRadio("Nein", 24, 104, 113, 17)
	if $loadGenreCount then
		GUICtrlSetState($settingsGui_Radio3, $GUI_CHECKED)
	else
		GUICtrlSetState($settingsGui_Radio4, $GUI_CHECKED)
	endif
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateButton("Speichern", 8, 136, 91, 25)
	GUICtrlSetOnEvent(-1,"saveSettings")
	GUICtrlCreateButton("Abbrechen", 112, 136, 91, 25)
	GUICtrlSetOnEvent(-1,"abortSettings")
	GUISetState(@SW_SHOW)
EndFunc

Func saveSettings()
	if GUICtrlRead($settingsGui_Radio1)=1 then
		IniWrite($settingsIniPfad,"General","LoadAllAtBegin","true")
	Else
		IniWrite($settingsIniPfad,"General","LoadAllAtBegin","false")
	endif
	if GUICtrlRead($settingsGui_Radio3)=1 then
		IniWrite($settingsIniPfad,"General","LoadGenreCounts","true")
	Else
		IniWrite($settingsIniPfad,"General","LoadGenreCounts","false")
	endif
	GUIDelete($settingsGui)
EndFunc

Func abortSettings()
	GUIDelete($settingsGui)
EndFunc

Func search()
	$searchString=GUICtrlRead($MainGui_Input1)
	$searchKategorie=GUICtrlRead($MainGui_Combo1)
	if GUICtrlRead($MainGui_Combo2)="hnlich" then
		$opt=true
	else
		$opt=false
	endif
	if $searchKategorie="Alle" then
		$array=MainGetDataRet("Select * from Buecher where id=0")
		$string=""
		for $i=1 to $iClumn step 1
			if $array<>"" then
				if $opt then
					$string&=$array[$i]&" like '%"&$searchString&"%' or "
				else
					$string&=$array[$i]&"='"&$searchString&"' or "
				endif
			endif
		next
		if $opt then
			$string&=$array[$iClumn+1]&" like '%"&$searchString&"%'"
		else
			$string&=$array[$iClumn+1]&"='"&$searchString&"'"
		endif
		;msgbox(48,"","Select * from Buecher where "&$string)
		getDataAndFillListview("Select * from Buecher where "&$string)
	else
		;msgbox(48,"","Select * from Buecher where "&$searchKategorie&" like '"&$searchString&"'")
		if $opt then
			getDataAndFillListview("Select * from Buecher where "&$searchKategorie&" like '%"&$searchString&"%'")
		else
			getDataAndFillListview("Select * from Buecher where "&$searchKategorie&"='"&$searchString&"'")
		endif
	endif
EndFunc

Func Reader($var=-1)
	local $var
	$item=$var
	if $item=-1 then
		Return -1
	endif
	$IE = _IECreateEmbedded ()
	$ReadGui = GUICreate("Reader", 800, 600-25, 0, 0,$WS_CAPTION +$WS_SYSMENU+ $WS_SIZEBOX +$WS_MINIMIZEBOX+$WS_MAXIMIZEBOX)
	$ReadObj = GUICtrlCreateObj($IE,10, 10, 800-20,  600-40)
	_IENavigate($IE, 'about:blank')
	;_IENavigate($IE,"file:///" & StringReplace(@ScriptDir, "\", "/") & "/Aakeson, Kim Fupz - Taeter wie wir/OEBPS/00000000000_cover.html")
	GUISetState(@SW_SHOW)
	;_IENavigate($IE, @ScriptDir&"\Aakeson, Kim Fupz - Taeter wie wir\OEBPS\b9783423415538_000017.xhtml")
	$file0=FileOpen("00000000000_cover.html")
	$file1=FileOpen("b9783423415538_000017.xhtml")
	$file2=FileOpen("b9783423415538_000044.xhtml")
	$file3=FileOpen("b9783423415538_000082.xhtml")
	$file4=FileOpen("b9783423415538_000086.xhtml")
	$file5=FileOpen("b9783423415538_0000646.xhtml")
	$html=FileRead($file0)&FileRead($file1)&FileRead($file2)&FileRead($file3)&FileRead($file4)&FileRead($file5)
	clipput($html)
	_IEDocWriteHTML($IE,$html)
	;_IEDocInsertHTML($ReadObj,$html)
	FileClose($file0)
	FileClose($file1)
	FileClose($file2)
	FileClose($file3)
	FileClose($file4)
	FileClose($file5)
EndFunc

Func changeData()
	$selected=_GUICtrlListView_GetSelectedIndices (GUICtrlGetHandle($MainGui_MainListView))
	if $selected<>"" then
		$selected=int($selected)
		GUISetState(@SW_DISABLE,$MainGui)
		$changeDataID=_GUICtrlListView_GetItemText($MainGui_MainListView,$selected,0)
		$GuiChangeData = GUICreate("Bearbeite Eintrag", 495, 400,-1,-1,-1,-1,$MainGui)
		$GuiChangeData_InputTitle = GUICtrlCreateInput("", 88, 8, 393, 21)
		$Label1 = GUICtrlCreateLabel("Titel:", 16, 8, 27, 17)
		$Label2 = GUICtrlCreateLabel("Autor:", 16, 32, 32, 17)
		$GuiChangeData_InputAutor = GUICtrlCreateInput("", 88, 32, 393, 21)
		$Label3 = GUICtrlCreateLabel("Genre:", 16, 56, 36, 17)
		$GuiChangeData_InputGenre = GUICtrlCreateInput("", 88, 56, 393, 21)
		$GuiChangeData_InputID = GUICtrlCreateInput("", 88, 80, 393, 21)
		$Label4 = GUICtrlCreateLabel("Identifier:", 16, 80, 47, 17)
		$GuiChangeData_InputDate = GUICtrlCreateInput("", 88, 104, 393, 21)
		$Label5 = GUICtrlCreateLabel("Erstelldatum:", 16, 104, 64, 17)
		$GuiChangeData_InputLang = GUICtrlCreateInput("", 88, 128, 393, 21)
		$Label6 = GUICtrlCreateLabel("Sprache:", 16, 128, 47, 17)
		$GuiChangeData_EditDesc = GUICtrlCreateEdit("", 88, 152, 393, 145)
		GUICtrlSetData(-1, "Edit1")
		$Label7 = GUICtrlCreateLabel("Beschreibung:", 16, 152, 72, 17)
		$Label8 = GUICtrlCreateLabel("Pfad:", 16, 312, 29, 17)
		$GuiChangeData_ButtonPfad = GUICtrlCreateButton("", 88, 312, 395, 25)
		GUICtrlSetOnEvent(-1,"changeData_path")
		$Label1 = GUICtrlCreateLabel("Anzahl Sterne:", 16, 342,72)
		$GuiChangeData_Combo=GUICtrlCreateCombo("0", 88, 342, 50, 20)
		GUICtrlSetData(-1,"1|2|3|4|5||")
		$ButtonSave = GUICtrlCreateButton("nderungen Speichern", 88, 372, 195, 25)
		GUICtrlSetOnEvent(-1,"changeData_save")
		$ButtonClose = GUICtrlCreateButton("Abbrechen", 288, 372, 195, 25)
		GUICtrlSetOnEvent(-1,"ChangeDataClose")
		GUISetOnEvent($GUI_EVENT_CLOSE, "ChangeDataClose",$GuiChangeData)
		GUISetState(@SW_SHOW)
		$array=MainGetDataRet("Select title,author,subject,identifier,date,language,path,description,rating from Buecher where id="&$changeDataID)
		GUICtrlSetData($GuiChangeData_InputTitle,$array[10])
		GUICtrlSetData($GuiChangeData_InputAutor,$array[11])
		GUICtrlSetData($GuiChangeData_InputGenre,$array[12])
		GUICtrlSetData($GuiChangeData_InputID,$array[13])
		GUICtrlSetData($GuiChangeData_InputDate,$array[14])
		GUICtrlSetData($GuiChangeData_InputLang,$array[15])
		GUICtrlSetData($GuiChangeData_ButtonPfad,$array[16])
		GUICtrlSetData($GuiChangeData_EditDesc,$array[17])
	endif
EndFunc

Func changeData_path()
	$path=FileOpenDialog("Whle Pfad",@ScriptDir,"Epub (*.epub)|All (*.*)",1)
	if @error then
	else
		GUICtrlSetData($GuiChangeData_ButtonPfad,$path)
	endif
EndFunc

Func changeData_save()
	if msgbox(4,"Speichern","Mchten sie die Daten wirklich speichern/berschreiben?")=6 then
		_SQLite_Exec($hDatabase,"UPDATE Buecher SET title = '"&GUICtrlRead($GuiChangeData_InputTitle)&"', author = '"&GUICtrlRead($GuiChangeData_InputAutor)&"', subject= '"&GUICtrlRead($GuiChangeData_InputGenre)&"', identifier = '"&GUICtrlRead($GuiChangeData_InputID)&"', date = '"&GUICtrlRead($GuiChangeData_InputDate)&"', language = '"&GUICtrlRead($GuiChangeData_InputLang)&"', path= '"&GUICtrlRead($GuiChangeData_ButtonPfad)&"',description = '"&GUICtrlRead($GuiChangeData_EditDesc)&"',rating = '"&GUICtrlRead($GuiChangeData_Combo)&"' WHERE id='"&$changeDataID&"'")
		$string=""
		if _GUICtrlListView_GetColumnCount($MainGui_MainListView)<>6 then
			$ar=MainGetDataRet("Select * from Buecher where id="&$changeDataID)
			$steps=UBound($ar)/2
			for $i=$steps+1 to UBound($ar)-1 step 1
				_GUICtrlListView_SetItemText($MainGui_MainListView,$selected,$ar[$i],$i-$steps-1)
			next
		else
			$ar=MainGetDataRet("Select id as ID,title as Name,author as Autor,subject as Genre,path as Pfad,rating as Bewertung  from Buecher where id="&$changeDataID)
			$steps=int(UBound($ar)/2)
			for $i=$steps+1 to UBound($ar)-1 step 1
				_GUICtrlListView_SetItemText($MainGui_MainListView,$selected,$ar[$i],$i-$steps-1)
			next
		endif
		gibInfos($selected)
		GUIDelete($GuiChangeData)
		GUISetState(@SW_ENABLE,$MainGui)
		WinActivate("Bcherverwaltung")
	endif
EndFunc

Func ChangeDataClose()
	GUIDelete($GuiChangeData)
	GUISetState(@SW_ENABLE,$MainGui)
	WinActivate("Bcherverwaltung")
EndFunc

Func gibInfos($var)
	GUICtrlSetData($MainGui_GroupRight_Bookname,"")
	GUICtrlSetData($MainGui_GroupRight_BookAuthor,"")
	GUICtrlSetData($MainGui_GroupRight_BookGenre,"")
	GUICtrlSetData($MainGui_GroupRight_BookIdentifier,"")
	GUICtrlSetData($MainGui_GroupRight_BookDate,"")
	GUICtrlSetData($MainGui_GroupRight_BookLanguage,"")
	GUICtrlSetData($MainGui_GroupRight_DataName,"")
	GUICtrlSetData($MainGui_GroupRight_Path,"")
	;GUICtrlSetData($MainGui_GroupRight_Description,"")
	_IEDocWriteHTML($MainGui_IE,"")
	GUICtrlSetImage($MainGui_GroupRight_Rating,"Images\sternBG.jpg")
	if $var<>-1 then ;alles zurcksetzen
		$array=MainGetDataRet("Select title,author,subject,identifier,date,language,path,description,rating from Buecher where id="&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$var,0)))
		;_ArrayDisplay($array)
		GUICtrlSetData($MainGui_GroupRight_Bookname,$array[10])
		GUICtrlSetData($MainGui_GroupRight_BookAuthor,$array[11])
		GUICtrlSetData($MainGui_GroupRight_BookGenre,$array[12])
		GUICtrlSetData($MainGui_GroupRight_BookIdentifier,$array[13])
		GUICtrlSetData($MainGui_GroupRight_BookDate,$array[14])
		GUICtrlSetData($MainGui_GroupRight_BookLanguage,$array[15])
		$rr=stringsplit($array[16],"\")
		GUICtrlSetData($MainGui_GroupRight_DataName,$rr[$rr[0]])
		GUICtrlSetData($MainGui_GroupRight_Path,$array[16])
		;GUICtrlSetData($MainGui_GroupRight_Description,$array[17])
		_IEDocWriteHTML($MainGui_IE,$array[17])
		if $array[18]="" then
			GUICtrlSetImage($MainGui_GroupRight_Rating,"Images\sternNotRated.jpg")
		else
			GUICtrlSetImage($MainGui_GroupRight_Rating,"Images\stern"&$array[18]&".jpg")
		endif
	EndIf
EndFunc

Func RateBook()
	$selected=_GUICtrlListView_GetSelectedIndices (GUICtrlGetHandle($MainGui_MainListView))
	if $selected<>"" then
		$selected=int($selected)
		GUISetState(@SW_DISABLE,$MainGui)
		$GuiRateChangeDataID=_GUICtrlListView_GetItemText($MainGui_MainListView,$selected,0)
		$GuiRate = GUICreate("Bewerten",250, 70,-1,-1,-1,-1,$MainGui)
		$Label1 = GUICtrlCreateLabel("Anzahl Sterne:", 10, 10,100)
		$GuiRate_Combo=GUICtrlCreateCombo("0",120,10,50)
		GUICtrlSetData(-1,"1|2|3|4|5||")
		GUICtrlCreateButton("Speichern",10,40,100)
		GUICtrlSetOnEvent(-1,"RateBook_save")
		GUICtrlCreateButton("Abbrechen",120,40,100)
		GUICtrlSetOnEvent(-1,"GuiRateClose")
		GUISetOnEvent($GUI_EVENT_CLOSE, "GuiRateClose",$GuiChangeData)
		GUISetState(@SW_SHOW,$GuiRate)
		$array=MainGetDataRet("Select rating from Buecher where id="&$GuiRateChangeDataID)
		GUICtrlSetImage($MainGui_GroupRight_Rating,"Iamges\stern"&$array[2]&".jpg")
	endif
EndFunc

Func GuiRateClose()
	GUIDelete($GuiRate)
	GUISetState(@SW_ENABLE,$MainGui)
	WinActivate("Bcherverwaltung")
EndFunc

Func RateBook_save()
	_SQLite_Exec($hDatabase,"UPDATE Buecher SET rating = '"&GUICtrlRead($GuiRate_Combo)&"' WHERE id='"&$GuiRateChangeDataID&"'")
	$string=""
	if _GUICtrlListView_GetColumnCount($MainGui_MainListView)<>6 then
		$ar=MainGetDataRet("Select * from Buecher where id="&$GuiRateChangeDataID)
		_ArrayDisplay($ar)
		$steps=UBound($ar)/2
		for $i=$steps+1 to UBound($ar)-1 step 1
			_GUICtrlListView_SetItemText($MainGui_MainListView,$selected,$ar[$i],$i-$steps-1)
		next
	else
		$ar=MainGetDataRet("Select id as ID,title as Name,author as Autor,subject as Genre,path as Pfad,rating as Bewertung  from Buecher where id="&$GuiRateChangeDataID)
		_ArrayDisplay($ar)
		$steps=int(UBound($ar)/2)
			for $i=$steps+1 to UBound($ar)-1 step 1
			_GUICtrlListView_SetItemText($MainGui_MainListView,$selected,$ar[$i],$i-$steps-1)
		next
	endif
	gibInfos($selected)
	GUIDelete($GuiRate)
	GUISetState(@SW_ENABLE,$MainGui)
	WinActivate("Bcherverwaltung")
EndFunc

Func copyPath()
	$sel=_GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($MainGui_MainListView))
	if $sel<>"" then
		ClipPut(@ScriptDir&MainGetDataRet("Select path from Buecher where id="&_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$sel,0))[2])
	endif
EndFunc

Func openBook()
	$sel=_GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($MainGui_MainListView))
	if $sel<>"" then
		open($sel)
	endif
EndFunc

Func openBookFolder()
	$sel=_GUICtrlListView_GetSelectedIndices(GUICtrlGetHandle($MainGui_MainListView));_GUICtrlListView_GetSelectionMark(GUICtrlGetHandle($MainGui_MainListView))
	if $sel<>"" then
		open($sel,1)
	endif
EndFunc

Func open($var,$opt=-1)
	;ffne Buch
	if $opt=-1 then
		ShellExecute ( @Scriptdir&MainGetDataRet("Select path as pfad from Buecher where id="&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$var,0)))[2])
	Else
		$str=MainGetDataRet("Select path as pfad from Buecher where id="&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),$var,0)))[2]
		ShellExecute ( @WindowsDir&"\explorer.exe","/select,"&'"'&@ScriptDir&$str&'"')
	endif
EndFunc

Func _genreSettings()
	$GenreSettingsGui=GUICreate("Bearbeite Eintrag", 600, 400,-1,-1,-1,-1,$MainGui)
	$GenreSettingsGui_ListView1=GUICtrlCreateListView("Name|Kreterien",10,70,580,320)
	_GUICtrlListView_SetColumnWidth(-1,0,200)
	_GUICtrlListView_SetColumnWidth(-1,1,355)
	$GenreSettings_ListViewMenu = GUICtrlCreateContextMenu($GenreSettingsGui_ListView1)
	$GenreSettings_ListViewMenuItem1 = GUICtrlCreateMenuItem("Lschen", $GenreSettings_ListViewMenu)
	GUICtrlSetOnEvent(-1, "_deleteGenreItem")
	$GenreSettings_ListViewMenuItem1 = GUICtrlCreateMenuItem("Bearbeiten", $GenreSettings_ListViewMenu)
	GUICtrlSetOnEvent(-1, "_changeGenreItem")
	GUICtrlCreateLabel("Name in der Liste:",10,10,200)
	GUICtrlCreateLabel("Suchkreterien mit Semikolon (;) getrennt:",220,10,270)
	$GenreSettingsGui_Input1=GUICtrlCreateInput("",10,40,200)
	$GenreSettingsGui_Input2=GUICtrlCreateInput("",220,40,370)
	GUICtrlSetTip ( -1,"Trennen sie Suchbegriffe mit einem Semikolon ( ; )"&@crlf&"% steht fr beliebige Zeichen"&@crlf&"Verwenden sie kein "&'"'&" ' "&'"'&' und kein " or " (umgeben von 2 Leerzeichen) in der Suche!',"Hinweis")
	GUICtrlCreateButton("Einfgen",480,10,100)
	GUICtrlSetOnEvent(-1,"_saveGenreSettings")
	GUISetOnEvent($GUI_EVENT_CLOSE, "closeGenreSettings",$GenreSettingsGui)
	_fillGenreSettingsListView()
	GUISetState(@SW_SHOW,$GenreSettingsGui)
EndFunc

Func _changeGenreItem()
	$ar=StringSplit(_GUICtrlListView_GetItemText($GenreSettingsGui_ListView1,_GUICtrlListView_GetSelectedIndices($GenreSettingsGui_ListView1,true)[1],1)," ; ",1)
	$string=""
	for $i=1 to UBound($ar)-1 step 1
		if StringInStr($ar[$i],"%")=1 then
			$ar[$i]=StringTrimLeft($ar[$i],1)
		endif
		if StringInStr($ar[$i],"%",0,-1)=StringLen($ar[$i]) then
			$ar[$i]=StringTrimRight($ar[$i],1)
		endif
		$string&=$ar[$i]
		if $i<>UBound($ar)-1 then
			$string&=";"
		endif
	next
	GUICtrlSetData($GenreSettingsGui_Input1,_GUICtrlListView_GetItemText($GenreSettingsGui_ListView1,_GUICtrlListView_GetSelectedIndices($GenreSettingsGui_ListView1,true)[1],0))
	GUICtrlSetData($GenreSettingsGui_Input2,$string)
EndFunc

Func _deleteGenreItem()
	$selected=_GUICtrlListView_GetSelectedIndices($GenreSettingsGui_ListView1,true)[1]
	$name=_GUICtrlListView_GetItemText($GenreSettingsGui_ListView1,$selected,0)
	IniDelete($GenreSettingsIniPath,"Genres",$name)
	_GUICtrlListView_DeleteItem($GenreSettingsGui_ListView1,$selected)
EndFunc

Func _saveGenreSettings()
	$name=GUICtrlRead($GenreSettingsGui_Input1)
	$kret=GUICtrlRead($GenreSettingsGui_Input2)
	$exist=IniRead($GenreSettingsIniPath,"Genres",$name,-1)
	GUICtrlSetData($GenreSettingsGui_Input1,"")
	GUICtrlSetData($GenreSettingsGui_Input2,"")
	if $kret<>"" and $name<>"" then
		$ar=StringSplit($kret,";")
		$string="subject LIKE '%"&$ar[1]&"%'"
		for $i=2 to UBound($ar)-1 step 1
			$string&=" or subject LIKE '%"&$ar[$i]&"%'"
		next
		IniWrite($GenreSettingsIniPath,"Genres",$name,$string)
		$ar2=StringSplit($string," or ",1)
		$string=_StringBetween($ar2[1],"'","'")[0]
		for $x=2 to UBound($ar2)-1 step 1
			$string&=" ; "&_StringBetween($ar2[$x],"'","'")[0]
		next
		if $exist<>-1 then
			_GUICtrlListView_SetItemText($GenreSettingsGui_ListView1,_GUICtrlListView_FindInText($GenreSettingsGui_ListView1,$name),$string,1)
		else
			GUICtrlCreateListViewItem($name&"|"&$string,$GenreSettingsGui_ListView1)
		endif
	else
		msgbox(48,"Fehler","Geben sie einen Namen und ein Kreterium an!")
	endif
EndFunc

Func _fillGenreSettingsListView()
	$ar=IniReadSection ( $GenreSettingsIniPath, "Genres" )
	for $i=1 to UBound($ar)-1 step 1
		$ar2=StringSplit($ar[$i][1]," or ",1)
		$string=_StringBetween($ar2[1],"'","'")[0]
		for $x=2 to UBound($ar2)-1 step 1
			$string&=" ; "&_StringBetween($ar2[$x],"'","'")[0]
		next
		GUICtrlCreateListViewItem($ar[$i][0]&"|"&$string,$GenreSettingsGui_ListView1)
	next
EndFunc

Func closeGenreSettings()
	GUIDelete($GenreSettingsGui)
EndFunc

;fllt listview mit ergebnis der db abfrage ---- IN SQLABFRAGE SORTIEREN
Func getDataAndFillListview($sql,$lastIsPath=false)
	GUICtrlSetData($WaitLabel,"Bitte warten Sie!"&@crlf&"Die Daten werden aus der Datenbank abgerufen!")
	GUICtrlSetData($WaitLabel_Progress,0)
	GUICtrlSetState($MainGui_MainListView,$GUI_DISABLE)
	GUICtrlSetState($MainGui_ListBox1,$GUI_DISABLE)
	GUICtrlSetState($MainGui_MainListView,$GUI_HIDE)
	GUICtrlSetState($WaitLabel,$GUI_SHOW)
	GUICtrlSetState($MainGui_Button1,$GUI_DISABLE)
	GUICtrlSetState($ProgressLabel,$GUI_SHOW)
	GUICtrlSetState($ProgressLabel1,$GUI_SHOW)
	sleep(10)
	MainGetData_self($sql)
	GUICtrlSetState($ProgressLabel,$GUI_HIDE)
	GUICtrlSetState($ProgressLabel1,$GUI_HIDE)
	GUICtrlSetData($WaitLabel,"Bitte warten sie!"&@crlf&"Die Liste wird mit Daten gefllt!")
	fillListView($aData,false,$lastIsPath)
EndFunc

;fllt die Haupt ListView mit den Daten des bergebenen Arrays
Func fillListView($array,$sort=true,$lastIsPath=false)
	_GUICtrlListView_BeginUpdate($MainGui_MainListView)
	GUICtrlSetState($WaitLabel_Progress,$GUI_SHOW)
	_GUICtrlListView_DeleteAllItems_self($MainGui_MainListView)
	GUICtrlSetData($WaitLabel,"Bitte warten sie!"&@crlf&"Die Liste wird gefllt!")
	for $i=0 to _GUICtrlListView_GetColumnCount($MainGui_MainListView)+1 step 1
		_GUICtrlListView_DeleteColumn($MainGui_MainListView,0)
	next
	if $lastIsPath then
		for $i=1 to $iClumn step 1
			_GUICtrlListView_AddColumn($MainGui_MainListView,$array[$i])
			_GUICtrlListView_SetColumnWidth ($MainGui_MainListView, $i-1, 300)
		next
		_GUICtrlListView_SetColumnWidth ($MainGui_MainListView, $iClumn-1, 450)
		_GUICtrlListView_HideColumn($MainGui_MainListView,0)
		$1perc=(UBound($array)-$iClumn)/100
		$aktPerc=0
		for $i=$iClumn+1 to UBound($array)-1 step $iClumn
			$string=""
			for $x=0 to $iClumn-2 step 1
				$string&=$array[$i+$x]&"|"
			next
			$rr=StringSplit($array[$i+$iClumn-1],"\")
			$string&=$rr[$rr[0]]
			GUICtrlCreateListViewItem($string,$MainGui_MainListView)
			if int($i/$1perc)<>$aktPerc then
				$aktPerc=int($i/$1perc)
				GUICtrlSetData($WaitLabel_Progress,$aktPerc)
			endif
		next
	else
		for $i=1 to $iClumn step 1
			_GUICtrlListView_AddColumn($MainGui_MainListView,$array[$i])
			_GUICtrlListView_SetColumnWidth ($MainGui_MainListView, $i-1, 200)
		next
		_GUICtrlListView_HideColumn($MainGui_MainListView,0)
		$1perc=(UBound($array)-$iClumn)/100
		$aktPerc=0
		for $i=$iClumn+1 to UBound($array)-1 step $iClumn
			$string=""
			for $x=0 to $iClumn-2 step 1
				$string&=$array[$i+$x]&"|"
			next
			$string&=$array[$i+$iClumn-1]
			GUICtrlCreateListViewItem($string,$MainGui_MainListView)
			if int($i/$1perc)<>$aktPerc then
				$aktPerc=int($i/$1perc)
				GUICtrlSetData($WaitLabel_Progress,$aktPerc)
			endif
		next
	endif
	if $sort then
		_GUICtrlListView_SimpleSort_self($MainGui_MainListView,false,1)
	endif
	_GUICtrlListView_EndUpdate($MainGui_MainListView)
	GUICtrlSetState($WaitLabel,$GUI_HIDE)
	GUICtrlSetState($WaitLabel_Progress,$GUI_HIDE)
	GUICtrlSetState($MainGui_ListBox1,$GUI_ENABLE)
	GUICtrlSetState($MainGui_MainListView,$GUI_SHOW)
	GUICtrlSetState($MainGui_MainListView,$GUI_ENABLE)
	GUICtrlSetState($MainGui_Button1,$GUI_ENABLE)
	GUICtrlSetData($MainGui_MainListView_CountLabel,"Eintrge in der Liste: "&_GUICtrlListView_GetItemCount($MainGui_MainListView))
EndFunc	;==>End fillListView

Func FilterListBox()
	$string=""
	$array=_GUICtrlListBox_GetSelItemsText($MainGui_ListBox1)
	if $array[0]<>0 then
		$all=false
		for $i=1 to $array[0]-1 step 1
			;$str=StringSplit($array[$i]," - ",1)
			if $array[$i]="Alle" then
				$all=true
			endif
			$array[$i]=StringRegExpReplace($array[$i]," - (.*)","")
			$string&=IniRead($GenreSettingsIniPath,"Genres",$array[$i],-1)&" or "
		next
		if $array[$array[0]]="Alle" then
			$all=true
		endif
		;$str=StringSplit($array[$array[0]]," ")
		$array[$array[0]]=StringRegExpReplace($array[$array[0]]," - (.*)","")
		$string&=IniRead($GenreSettingsIniPath,"Genres",$array[$i],-1)
		;msgbox(48,"",$string)
		if $all=true then
			getDataAndFillListview("Select id as ID,title as Name,author as Autor,subject as Genre,path as Pfad,rating as Bewertung from Buecher where 1 ORDER BY title ASC",true)
		else
			getDataAndFillListview("Select id as ID,title as Name,author as Autor,subject as Genre,path as Pfad,rating as Bewertung from Buecher where "&$string&" ORDER BY title ASC",true)
		endif
	else
		GUICtrlSetState($MainGui_MainListView,$GUI_DISABLE)
		GUICtrlSetState($MainGui_ListBox1,$GUI_DISABLE)
		GUICtrlSetState($MainGui_MainListView,$GUI_HIDE)
		GUICtrlSetState($WaitLabel,$GUI_SHOW)
		GUICtrlSetState($MainGui_Button1,$GUI_DISABLE)
		GUICtrlSetState($WaitLabel_Progress,$GUI_SHOW)
		_GUICtrlListView_DeleteAllItems_self($MainGui_MainListView)
		GUICtrlSetState($MainGui_MainListView,$GUI_ENABLE)
		GUICtrlSetState($MainGui_ListBox1,$GUI_ENABLE)
		GUICtrlSetState($MainGui_MainListView,$GUI_SHOW)
		GUICtrlSetState($WaitLabel,$GUI_HIDE)
		GUICtrlSetState($MainGui_Button1,$GUI_ENABLE)
		GUICtrlSetState($WaitLabel_Progress,$GUI_HIDE)
		GUICtrlSetData($MainGui_MainListView_CountLabel,"Eintrge in der Liste: "&_GUICtrlListView_GetItemCount($MainGui_MainListView))
	endif
EndFunc

Func MainGetData_self($sql)
	$aData=""
	$iRow=""
	$iClumn=""
	GUICtrlSetState($ProgressLabel,$GUI_SHOW)
	_SQLite_GetTable_self($hDatabase, $sql,$aData, $iRow, $iClumn)
	GUICtrlSetState($ProgressLabel,$GUI_HIDE)
	If @error then
		ConsoleWriteError("Fehler in der Sql-Abfrage:"&$sql)
		return -1
	EndIf
	return 1
EndFunc ;==>End MainGetData

;speichert die Sql-Abfrage in die globalen Variablen $aData, $iRow, $iClumn
Func MainGetData($sql)
	$aData=""
	$iRow=""
	$iClumn=""
	_SQLite_GetTable($hDatabase, $sql,$aData, $iRow, $iClumn)
	If @error then
		ConsoleWriteError("Fehler in der Sql-Abfrage:"&$sql)
		return -1
	EndIf
	return 1
EndFunc ;==>End MainGetData

Func MainGetDataRet($sql)
	local $aData1,$iRow1,$iClumn1
	_SQLite_GetTable($hDatabase, $sql,$aData1, $iRow1, $iClumn1)
	If @error then
		ConsoleWrite("Fehler in der Sql-Abfrage:"&$sql&@crlf)
		return -1
	EndIf
	return $aData1
EndFunc ;==>End MainGetData

Func _MouseDown()
	$mouseDown=_Mouse_Control_GetInfoAdlib()
EndFunc

Func _MouseUp()
	if $mouseDown then
		;If _IsMouseInWindow() = False Then
		if _GUICtrlListView_GetSelectedIndices (GUICtrlGetHandle($MainGui_MainListView))<>"" then
            $mousePos = MouseGetPos()
            $wInfo = _WinInfoFromPoint($mousePos[0], $mousePos[1])
			$pfadtmp=@Scriptdir&MainGetDataRet("Select path as pfad from Buecher where id="&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),_GUICtrlListView_GetSelectedIndices (GUICtrlGetHandle($MainGui_MainListView)),0)))[2]
            If $wInfo[1] = "SysListView32" And $wInfo[3] = "Progman" Then
                ;Detect Desktop
                FileCopy($pfadtmp , @DesktopDir)
				msgbox(48,"","filecopy")
            ElseIf $wInfo[1] = "SysListView32" And $wInfo[3] = "CabinetWClass" Then
                ;Detect Explorer.exe Window!!!
                $oldData = _ClipBoard_GetData()
                $newData = _ClipPutFile($pfadtmp)
                $conSend = ControlSend($wInfo[4], "", "SysListView321", "Paste: ^v")
                Sleep(1000)
                _ClipBoard_SetData($oldData)
                ;DoDropFiles($wInfo[4], "C:\testfile.txt") - Doesn't Work :(
				msgbox(48,"","controlSend")
            Else
                DoDropFiles($wInfo[4], $pfadtmp)
				;msgbox(48,"","DoDropFiles")
            EndIf
		EndIf
		;_Mouse_Control_GetInfoAdlib(@Scriptdir&MainGetDataRet("Select path as pfad from Buecher where id="&int(_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),_GUICtrlListView_GetSelectionMark (GUICtrlGetHandle($MainGui_MainListView)),0)))[2])
		$mouseDown=false
	endif
EndFunc

Func WM_COMMAND($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg
    Local $hWndFrom, $iIDFrom, $iCode, $hWndListBox
    If Not IsHWnd($MainGui_ListBox1) Then $hWndListBox = GUICtrlGetHandle($MainGui_ListBox1)
    $hWndFrom = $ilParam
    $iIDFrom = BitAND($iwParam, 0xFFFF) ; Low Word
    $iCode = BitShift($iwParam, 16) ; Hi Word
    Switch $hWndFrom
        Case $MainGui_ListBox1, GUICtrlGetHandle($MainGui_ListBox1)
            Switch $iCode
				Case $LBN_DBLCLK ; Sent when the user double-clicks a string in a list box
					$x=_GUICtrlListBox_GetCurSel($MainGui_ListBox1)
					#cs
					$ar=_GUICtrlListBox_GetSelItems($MainGui_ListBox1)
					for $i=1 to $ar[0] step 1
						_GUICtrlListBox_SetSel($MainGui_ListBox1,$ar[$i],false)
					next
					#ce
					_GUICtrlListBox_SelItemRange($MainGui_ListBox1, 0, _GUICtrlListBox_GetCount($MainGui_ListBox1), False)
					_GUICtrlListBox_SetSel($MainGui_ListBox1,$x,true)
					FilterListBox()
                ;Case $LBN_ERRSPACE ; Sent when a list box cannot allocate enough memory to meet a specific request
                ;Case $LBN_KILLFOCUS ; Sent when a list box loses the keyboard focus
                ;Case $LBN_SELCANCEL ; Sent when the user cancels the selection in a list box
			    ;Case $LBN_SETFOCUS ; Sent when a list box receives the keyboard focus
				Case $LBN_SELCHANGE ; Sent when the selection in a list box has changed
					FilterListBox()
            EndSwitch
	EndSwitch
    Return $GUI_RUNDEFMSG
 EndFunc   ;==>WM_COMMAND

Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg, $iwParam
    Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $hWndListView, $tInfo
    $hWndListView = $MainGui_MainListView
    If Not IsHWnd($MainGui_MainListView) Then $hWndListView = GUICtrlGetHandle($MainGui_MainListView)

    $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
    $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
    $iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
    $iCode = DllStructGetData($tNMHDR, "Code")
    Switch $hWndFrom
		Case $hWndListView
            Switch $iCode
                Case $LVN_COLUMNCLICK ; Eine Spalte wurde angeklickt
                    $tInfo = DllStructCreate($tagNMLISTVIEW, $ilParam)
					GUICtrlSetState($MainGui_MainListView,$GUI_DISABLE)
					GUICtrlSetState($MainGui_ListBox1,$GUI_DISABLE)
					GUICtrlSetState($MainGui_MainListView,$GUI_HIDE)
					GUICtrlSetState($WaitLabel,$GUI_SHOW)
					GUICtrlSetState($WaitLabel_Progress,$GUI_SHOW)
					GUISetState(@SW_DISABLE,$MainGui)
                    _GUICtrlListView_SimpleSort_self($hWndListView, false, DllStructGetData($tInfo, "SubItem"))
					GUISetState(@SW_ENABLE,$MainGui)
					GUICtrlSetState($WaitLabel,$GUI_HIDE)
					GUICtrlSetState($WaitLabel_Progress,$GUI_HIDE)
					GUICtrlSetState($MainGui_MainListView,$GUI_ENABLE)
					GUICtrlSetState($MainGui_ListBox1,$GUI_ENABLE)
					GUICtrlSetState($MainGui_MainListView,$GUI_SHOW)
				Case $NM_CLICK;$NM_DBLCLK
					$s=_GUICtrlListView_GetSelectedIndices($hWndListView)
					if $s<>"" Then;_GUICtrlListView_GetSelectionMark ($hWndListView)
						gibInfos($s)
					else
						gibInfos(-1)
					EndIf
				Case $NM_DBLCLK
					;Reader(_GUICtrlListView_GetSelectionMark ($hWndListView))
					open(_GUICtrlListView_GetSelectedIndices ($hWndListView))
            EndSwitch
    EndSwitch
    Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY

Func WM_DROPFILES_FUNC($hWnd, $msgID, $wParam, $lParam)
	;msgbox(48,"",@ScriptDir&MainGetDataRet("Select path from Buecher where id="&_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),_GUICtrlListView_GetSelectionMark(GUICtrlGetHandle($MainGui_MainListView)),0))[2])
	;_Mouse_Control_GetInfoAdlib(@ScriptDir&MainGetDataRet("Select path from Buecher where id="&_GUICtrlListView_GetItemText(GUICtrlGetHandle($MainGui_MainListView),_GUICtrlListView_GetSelectionMark(GUICtrlGetHandle($MainGui_MainListView)),0))[2])
	#cs
    Local $nSize, $pFileName
    Local $szDrive, $szDir, $szFName, $szExt
    Local $nAmt = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', 0xFFFFFFFF, 'ptr', 0, 'int', 0)
    For $i = 0 To $nAmt[0] - 1
        $nSize = DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', 0, 'int', 0)
        $nSize = $nSize[0] + 1
        $pFileName = DllStructCreate('wchar[' & $nSize & ']')
        DllCall('shell32.dll', 'int', 'DragQueryFileW', 'hwnd', $wParam, 'int', $i, 'ptr', DllStructGetPtr($pFileName), 'int', $nSize)
        ReDim $gaDropFiles[$i + 1]
        $gaDropFiles[$i] = DllStructGetData($pFileName, 1)
        $pFileName = 0
        $PathSplit = _PathSplit($gaDropFiles[$i], $szDrive, $szDir, $szFName, $szExt)
        GUICtrlCreateListViewItem($PathSplit[3] & "|" & $PathSplit[4] & "|" & $PathSplit[1] & $PathSplit[2], $listview)
    Next
	#ce
EndFunc   ;==>WM_DROPFILES_FUNC

Func WM_GETMINMAXINFO($hwnd, $Msg, $wParam, $lParam)
    $tagMaxinfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
    DllStructSetData($tagMaxinfo, 7, 1050) ; min X
    DllStructSetData($tagMaxinfo, 8, 830) ; min Y
    DllStructSetData($tagMaxinfo, 9, 3000 ); max X
    DllStructSetData($tagMaxinfo, 10, 3000 ) ; max Y
    Return 0
EndFunc   ;==>WM_GETMINMAXINFO

Func MainGui_Close()
	$GuiState=WinGetState("Bcherverwaltung")
	$GuiPos=WinGetPos("Bcherverwaltung")
	IniWrite($settingsIniPfad,"GuiSettings","PosX",$GuiPos[0])
	IniWrite($settingsIniPfad,"GuiSettings","PosY",$GuiPos[1])
	IniWrite($settingsIniPfad,"GuiSettings","Width",$GuiPos[2])
	IniWrite($settingsIniPfad,"GuiSettings","Height",$GuiPos[3])
	IniWrite($settingsIniPfad,"GuiSettings","State",$GuiState)
	_SQLite_Close($hDatabase) ;Datenbank schlieen
    _SQLite_Shutdown(); sqlite herunterfahren
    exit
EndFunc

Func MainGui_Minimize()

EndFunc

Func MainGui_Maximize()

EndFunc

;------------------------------------------------------------------------------------------IMPORT_Folder
Func ImportClose()
	$import_abbrechen=true
EndFunc

Func ImportFolder()
	$counter=0
	$file=FileSelectFolder ( "Whle Ordner", "root dir" ,2)
	if $file="" then
		return -1
	endif
	$ImportGui=GUICreate("Importiere Bcher",400,110,-1,-1,-1,-1,$MainGui)
	$ImportLabel=GUICtrlCreateLabel("Bitte warten! Speicherort der XMLS wird geleert!",10,10,250,20)
	$ImportLabel1=GUICtrlCreateLabel("0/0",270,10,190,20)
	$ImportProgressBar=GUICtrlCreateProgress(10,30,380,50)
	$ImportInterrupt=GUICtrlCreateButton("Abbrechen",150,85,100,20)
	GUICtrlSetOnEvent($ImportInterrupt,"ImportClose")
	GUISetState(@SW_SHOW,$ImportGui)
	DirRemove(@ScriptDir&"\XMLS",1)
	DirRemove(@ScriptDir&"\temp",1)
	DirCreate(@ScriptDir&"\XMLS")
	GUICtrlSetData($ImportLabel,"Bitte warten! Durchsuche Ordner nach Dateien!")
	$s=ZeigeDateien($file)
	GUICtrlSetData($ImportLabel,"Bitte warten! Dateien werden extrahiert!")
	$UnZipTime=0
	$var=UBound($s)/100
	GUICtrlSetData($ImportLabel1,"0/"&UBound($s))
	$aktPerc=0
	for $l=1 to UBound($s)-1 step 1 ;UBound($s)-1
		$file=$s[$l]
		$pfad=$file
		$pfad=StringReplace($pfad,@ScriptDir,"")
		;msgbox(48,"","Select count(id) from Buecher where path='"&$pfad&"'")
		;_ArrayDisplay(MainGetDataRet("Select count(id) from Buecher where path='"&$pfad&"'"))
		if Not StringInStr($pfad,".epub",1)then
			$ExtractFails&="Kein Epub: "&$pfad&@crlf
		endif
		if MainGetDataRet("Select count(id) from Buecher where path='"&$pfad&"'")[2]>0 then
			$isInDB&="Bereit erfasst: "&$pfad&@crlf
		endif
		if StringInStr($pfad,".epub",1) and MainGetDataRet("Select count(id) from Buecher where path='"&$pfad&"'")[2]<1 then
			$UnZipTime=0
			AdlibRegister("observateZip",1000)
			_7ZipProgress(@ScriptDir&"\7zG.exe", $file,@ScriptDir&"\temp", false)
			AdlibUnRegister("observateZip")
			$xar=stringsplit($file,"\")
			$xar=stringsplit($xar[$xar[0]],".")
			$str=""
			for $i=1 to $xar[0]-1 step 1
				$str&=$xar[$i]
			next
			$file=FileOpen(@ScriptDir&"\temp\META-INF\container.xml")
			$content=FileRead($file)
			FileClose($file)
			$sc1=StringSplit($content,'<rootfile full-path="',1)
			if $sc1[0]<2 then
				$fileHandle=FileOpen(@ScriptDir&"\XMLS\error.dat",1)
				FileWriteLine($fileHandle,$pfad)
				FileClose($fileHandle)
				$ExtractFails&="Unbekannter Fehler: "&$pfad&@crlf
			else
				$fileHandle=FileOpen(@ScriptDir&"\XMLS\log.dat",1)
				FileWriteLine($fileHandle,$str&"#|#|#"&$pfad)
				FileClose($fileHandle)
				$sc1=StringSplit($sc1[2],'"',1)
				if $sc1<>"" then
					FileCopy(@ScriptDir&"\temp\"&$sc1[1],@ScriptDir&"\XMLS\"&$str&".xml")
					;$fileHandle=FileOpen(@ScriptDir&"\XMLS\"&$str&".pfad",1)
					;FileWriteLine($fileHandle,$pfad)
					;FileClose($fileHandle)
				endif
			endif
			DirRemove ( @ScriptDir&"\temp",1)
			while FileExists(@ScriptDir&"\temp")
				sleep(10)
				DirRemove ( @ScriptDir&"\temp",1)
			WEnd
		endif
		if int($l/$var)<>$aktPerc then
			$aktPerc=int($l/$var)
			GUICtrlSetData($ImportProgressBar,$aktPerc)
		endif
		GUICtrlSetData($ImportLabel1,$l&"/"&UBound($s))
		if $import_abbrechen then
			DirRemove(@ScriptDir&"\XMLS",1)
			exitloop
		endif
	next
	GUIDelete($ImportGui)
	if not($import_abbrechen) then
		ImportToDB()
	endif
	$import_abbrechen=false
EndFunc

Func observateZip()
	$UnZipTime+=1
	if $UnZipTime=20 then
		ProcessClose("7zG.exe")
	endif
EndFunc

Func _7ZipProgress($s7ZipEXE, $sSource, $sDestination = @TempDir, $fPack = True, $sPackType = '7z', $iPackLv = 5, $sAdditionalCommands = '', $sFuncToCall = '', $iMinPercentage = 0, $iMaxPercentage = 100, $iUpdateRate = 50)
    Local $sCommand, $iSize, $hTimeBefore, $iPID, $aProcessStats, $iPercentage
    If Not FileExists($s7ZipEXE) Or Not FileExists($sSource) Or $sDestination = '' Then
        Return SetError(1, Default, 0)
    EndIf
    If $iPackLv < 1 Or $iPackLv > 9 Or Not StringRegExp($sPackType, '7z|zip|wim|tar') Then
        Return SetError(2, Default, 0)
    EndIf
    If $sAdditionalCommands <> '' Then
        $sAdditionalCommands = ' ' & $sAdditionalCommands
    EndIf
    If $fPack Then
        $sCommand = ' a "' & $sDestination & '" "' & $sSource & '" -t' & $sPackType & ' -mx=' & $iPackLv & $sAdditionalCommands
    Else
        $sCommand = ' x -o"' & $sDestination & '" "' & $sSource & '"' & $sAdditionalCommands
    EndIf
    If StringInStr(FileGetAttrib($sSource), 'D') Then
        $iSize = DirGetSize($sSource)
    Else
        $iSize = FileGetSize($sSource)
    EndIf
    $hTimeBefore = TimerInit()
    $iPID = Run($s7ZipEXE & ' ' & $sCommand, @TempDir, @SW_HIDE)
    While ProcessExists($iPID)
        $aProcessStats = ProcessGetStats($iPID, 1)
        If $aProcessStats = 0 Then
            SetError(3, Default, 0)
        EndIf
        Sleep($iUpdateRate)
    WEnd
    Return SetExtended(TimerDiff($hTimeBefore), $s7ZipEXE & ' ' & $sCommand)
EndFunc

Func ZeigeDateien($pfad, $typ = 0, $maxAnz = 500000) ; typ=0: Dateien, typ=1: Ordner, typ=2: Alles
  If $typ < 2 Then
    Local $ordner[$maxAnz + 1], $i = 1
    If $typ = 0 Then Local $datei[$maxAnz + 1], $k = 1
    $ordner[0] = $pfad
    For $j = 0 To $maxAnz
      $suchhandle = FileFindFirstFile($ordner[$j] & '\*.*')
      $ordner[$j] &= '\'
      Do
        $objekt = FileFindNextFile($suchhandle)
        If @error Then ExitLoop ; Keine Daten mehr vorhanden
        If StringInStr(FileGetAttrib($ordner[$j] & $objekt), 'D', 2) Then ; Ordner
          If Not StringInStr($ordner[$j] & $objekt, $pfad, 2) Then ExitLoop 2
          $ordner[$i] = $ordner[$j] & $objekt
          $i += 1
        ElseIf $typ = 0 Then
          $datei[$k] = $ordner[$j] & $objekt
          $k += 1
        EndIf
      Until False
      $ordner[$j] = StringTrimRight($ordner[$j], 1) ; entfernt '/' am Ende
      FileClose($suchhandle)
    Next
    If $typ = 0 Then
      ReDim $datei[$k]
      $datei[0] = $k - 1
      Return $datei
    Else
      ReDim $ordner[$j]
      $ordner[0] = $j - 1
      Return $ordner
    EndIf
  Else
    Local $a = ZeigeDateien($pfad, 0)
    Local $b = ZeigeDateien($pfad, 1)
    Local $c[UBound($a) + UBound($b)]
    For $i = 0 To UBound($a) - 1
      $c[$i] = $a[$i]
    Next
    ReDim $b[UBound($b) + 1]
    For $i = UBound($a) To UBound($c) - 1
      $c[$i] = $b[$i - UBound($a) + 1]
    Next
    ReDim $c[UBound($c) - 1]
    $c[0] = UBound($c) - 1
    Return $c
  EndIf
EndFunc
;------------------------------------------------------------------------------------------IMPORT_Folder
;------------------------------------------------------------------------------------------WriteToDB
Func ImportToDB()
	$DBImportGui=GUICreate("Import to sqlite",200,130,-1,-1,-1,-1,$MainGui)
	$DBImportGui_Label=GUICtrlCreateLabel("Bitte warten! Dateien werden in Datenbank eingetragen!",10,10,180,30)
	$DBImportGui_Progress=GUICtrlCreateProgress(10,40,180,40)
	$DBImportGui_Label1=GUICtrlCreateLabel("0/0",80,90,180,30)
	$DBImportGui_Abbrechen1=GUICtrlCreateButton("Abbrechen",10,90,60,30)
	GUICtrlSetOnEvent($DBImportGui_Abbrechen1,"ImportClose")
	GUISetState(@sw_show,$DBImportGui)
	$import_abbrechen=false
	$bereitsVorhanden=""
	$importiert=""
	$mFile=FileOpen("XMLS\log.dat")
	$mFileData=FileRead($mFile)
	$mFileDataArray=StringSplit($mFileData,@crlf,1)
	$sql='SELECT MAX(id) FROM Buecher'
	local $aData1,$iRow1,$iClumn1
	_SQLite_GetTable($hDatabase, $sql,$aData1, $iRow1, $iClumn1)
	$var=(UBound($mFileDataArray)-1)/100
	$aktPerc=0
	$maxId=$aData1[2]
	GUICtrlSetData($DBImportGui_Label1,"0/"&UBound($mFileDataArray)-1)
	for $i=1 to UBound($mFileDataArray)-2 step 1
		$sql='Select id from Buecher where path="'&StringSplit($mFileDataArray[$i],"#|#|#",1)[2]&'"'
		local $aData1,$iRow1,$iClumn1
		_SQLite_GetTable($hDatabase, $sql,$aData1, $iRow1, $iClumn1)
		If @error then
			ConsoleWrite("Fehler in der Sql-Abfrage:"&$sql&@crlf)
			return -1
		EndIf
		if int($aData1[0])<2 then
			$sfile="XMLS\"&StringSplit($mFileDataArray[$i],"#|#|#",1)[1]&".xml"
			$file=FileOpen($sfile)
			$str=FileRead($file)
			$author=_HTMLDecode(between($str,"<dc:creator","/dc:creator>"))
			$description=_HTMLDecode(between($str,"<dc:description","/dc:description>"))
			$title=_HTMLDecode(between($str,"<dc:title","/dc:title>"))
			$date=_HTMLDecode(between($str,"<dc:date","/dc:date>"))
			$identifier=_HTMLDecode(between($str,"<dc:identifier","/dc:identifier>"))
			$subject=_HTMLDecode(between($str,"<dc:subject","/dc:subject>"))
			$language=_HTMLDecode(between($str,"<dc:language","/dc:language>"))
			$sSQL = "INSERT INTO `Buecher`(`ID`,`Identifier`,`author`,`description`,`title`,`subject`,`date`,`path`,`language`) VALUES ('"&$maxId+$i&"','"&$identifier&"','"&$author&"','"&$description&"','"&$title&"','"&$subject&"','"&$date&"',"&'"'&StringSplit($mFileDataArray[$i],"#|#|#",1)[2]&'"'&",'"&$language&"')"
			_SQLite_Exec($hDatabase, $sSQL)
			$importiert&="Erfolgreich: "&StringSplit($mFileDataArray[$i],"#|#|#",1)[2]&@crlf
		else
			$bereitsVorhanden="Bereits erfasst: "&StringSplit($mFileDataArray[$i],"#|#|#",1)[2]&@crlf
		endif
		if int($i/$var)<>$aktPerc then
			$aktPerc=int($i/$var)
			GUICtrlSetData($DBImportGui_Progress,$aktPerc)
		endif
		GUICtrlSetData($DBImportGui_Label1,$i&"/"&UBound($mFileDataArray)-1)
		if $import_abbrechen then
			ExitLoop
		endif
	next
	GUIDelete($DBImportGui)
	$ImportGui=GUICreate("Ergebnis",800,605,-1,-1,-1,-1,$MainGui)
	$ImportLabel=GUICtrlCreateLabel("Ergebnis des Importierens:",10,10,180,20)
	GUICtrlCreateLabel("Fehler beim Extrahieren:",10,30,250,15)
	GUICtrlCreateLabel("Fehler beim Importieren oder bereits vorhanden:",10,215,250,15)
	GUICtrlCreateLabel("Erfolgreiche Importierung:",10,400,250,15)
	$ImportErg1=GUICtrlCreateEdit($ExtractFails&FileRead("XMLS\error.dat"),10,55,750,155)
	$ImportErg2=GUICtrlCreateEdit($isInDB&$bereitsVorhanden,10,240,750,155)
	$ImportErg3=GUICtrlCreateEdit($importiert,10,425,750,155)
	$ImportInterrupt=GUICtrlCreateButton("OK",660,585,100,20)
	GUICtrlSetOnEvent($ImportInterrupt,"importOk")
	GUISetState(@SW_SHOW,$ImportGui)
	DirRemove(@ScriptDir&"\XMLS",1)
	DirRemove ( @ScriptDir&"\temp",1)
	$isInDB=""
	$ExtractFails=""
	setGenre()
	if $loadAtBegin then
		getDataAndFillListview("Select id as ID,title as Name,author as Autor,subject,path as Genre from Buecher where 1 ORDER BY title ASC",true)
	endif
EndFunc

Func importOk()
	GUIDelete($ImportGui)
EndFunc

Func between($str,$str1,$str2)
	$gib1=_StringBetween($str,$str1,$str2)
	if @error then
	else
		return StringReplace(StringReplace(_StringBetween($gib1[0],">","<")[0],"'","`"),'"',"`")
	endif
	return ""
EndFunc
;------------------------------------------------------------------------------------------WriteToDB

Func _GUICtrlListView_SimpleSort_self($hWnd, ByRef $vSortSense, $iCol, $fToggle = True)
	GUICtrlSetData($WaitLabel_Progress,0)
	GUICtrlSetData($WaitLabel,"Bitte warten sie!"&@crlf&"Die Liste wird sortiert!")
	sleep(100)
	Local $iItemCount = _GUICtrlListView_GetItemCount($hWnd)
	If $iItemCount Then
		Local $iDescending = 0
		If UBound($vSortSense) Then
			$iDescending = $vSortSense[$iCol]
		Else
			$iDescending = $vSortSense
		EndIf
		Local $vSeparatorChar = Opt('GUIDataSeparatorChar')
		Local $iColumnCount = _GUICtrlListView_GetColumnCount($hWnd)
		;Local Enum $iIndexValue = $iColumnCount, $iItemParam ; Additional columns for the index value and ItemParam
		Local $aListViewItems[$iItemCount][$iColumnCount + 2]

		;Local $aSelectedItems = StringSplit(_GUICtrlListView_GetSelectedIndices($hWnd), $vSeparatorChar)
		;Local $aCheckedItems = __GUICtrlListView_GetCheckedIndices($hWnd)
		Local $sItemText, $iFocused = -1
		Local $var=$iItemCount/100	;PROGRESSBAR
		Local $aktPerc=0	;PROGRESSBAR
		For $i = 0 To $iItemCount - 1 ; Rows
			;If $iFocused = -1 Then
			;	If _GUICtrlListView_GetItemFocused($hWnd, $i) Then $iFocused = $i
			;EndIf
			;_GUICtrlListView_SetItemSelected($hWnd, $i, False)
			;_GUICtrlListView_SetItemChecked($hWnd, $i, False)
			For $j = 0 To $iColumnCount - 1 ; Columns
				$sItemText = StringStripWS(_GUICtrlListView_GetItemText($hWnd, $i, $j), 2)
				If (StringIsFloat($sItemText) Or StringIsInt($sItemText)) Then
					$aListViewItems[$i][$j] = Number($sItemText)
				Else
					$aListViewItems[$i][$j] = $sItemText
				EndIf
			Next
			;$aListViewItems[$i][$iIndexValue] = $i ; Index value
			;$aListViewItems[$i][$iItemParam] = _GUICtrlListView_GetItemParam($hWnd, $i) ; ItemParam
			if int(($i/$var)/2)<>$aktPerc then	;PROGRESSBAR
				$aktPerc=int(($i/$var)/2)
				GUICtrlSetData($WaitLabel_Progress,$aktPerc)
			endif
		Next

		; Sort the ListView array
		_ArraySort($aListViewItems, $iDescending, 0, 0, $iCol)

		For $i = 0 To $iItemCount - 1 ; Rows
			For $j = 0 To $iColumnCount - 1 ; Columns
				_GUICtrlListView_SetItemText($hWnd, $i, $aListViewItems[$i][$j], $j)
			Next

			;_GUICtrlListView_SetItemParam($hWnd, $i, $aListViewItems[$i][$iItemParam]) ; ItemParam
			#cs
			For $j = 1 To $aSelectedItems[0]
				If $aListViewItems[$i][$iIndexValue] = $aSelectedItems[$j] Then
					If $aListViewItems[$i][$iIndexValue] = $iFocused Then
						_GUICtrlListView_SetItemSelected($hWnd, $i, True, True)
					Else
						_GUICtrlListView_SetItemSelected($hWnd, $i, True)
					EndIf
					ExitLoop
				EndIf
			Next
			For $j = 1 To $aCheckedItems[0]
				If $aListViewItems[$i][$iIndexValue] = $aCheckedItems[$j] Then
					_GUICtrlListView_SetItemChecked($hWnd, $i, True)
					ExitLoop
				EndIf
			Next
			#ce
			if int(50+(($i/$var)/2))<>$aktPerc then	;PROGRESSBAR
				$aktPerc=int(50+($i/$var)/2)
				GUICtrlSetData($WaitLabel_Progress,$aktPerc)
			endif
		Next
		If $fToggle Then ; Automatic sort sense toggle
			If UBound($vSortSense) Then
				$vSortSense[$iCol] = Not $iDescending
			Else
				$vSortSense = Not $iDescending
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_GUICtrlListView_SimpleSort

Func _GUICtrlListView_DeleteAllItems_self($hWnd)
	GUICtrlSetData($WaitLabel_Progress,0)
	GUICtrlSetData($WaitLabel,"Bitte warten sie!"&@crlf&"Die Liste wird geleert!")
	sleep(100)
	; Check if deletion necessary
	If _GUICtrlListView_GetItemCount($hWnd) = 0 Then Return True
	Local Const $LV_WM_SETREDRAW = 0x000B
	; Determine ListView type
    Local $cCID = 0
    If IsHWnd($hWnd) Then
        ; Check if the ListView has a ControlID
        $cCID = _WinAPI_GetDlgCtrlID($hWnd)
    Else
        $cCID = $hWnd
        ; Get ListView handle
        $hWnd = GUICtrlGetHandle($hWnd)
    EndIf
	; If native ListView - could be either type of item
	If $cCID Then
		; Disable the redrawing message
		GUICtrlSendMsg($cCID, $LV_WM_SETREDRAW, False, 0)
		; Try deleting as native items
		Local $iParam = 0
		Local $var=_GUICtrlListView_GetItemCount($hWnd)/100	;PROGRESSBAR
		Local $aktPerc=0	;PROGRESSBAR
		For $iIndex = _GUICtrlListView_GetItemCount($hWnd) - 1 To 0 Step -1
			$iParam = _GUICtrlListView_GetItemParam($hWnd, $iIndex)
			; Check if LV item
			If GUICtrlGetState($iParam) > 0 And GUICtrlGetHandle($iParam) = 0 Then
				GUICtrlDelete($iParam)
			EndIf
			if int(($iIndex/$var))<>$aktPerc then	;PROGRESSBAR
				$aktPerc=100-int(($iIndex/$var))
				GUICtrlSetData($WaitLabel_Progress,$aktPerc)
			endif
		Next
		; Enable the redrawing message
		GUICtrlSendMsg($cCID, $LV_WM_SETREDRAW, True, 0)
		; Return if no items left
		If _GUICtrlListView_GetItemCount($hWnd) = 0 Then Return True
	EndIf
	; Has to be UDF Listview and/or UDF items
	GUICtrlSetData($WaitLabel_Progress,0)
	Return _SendMessage($hWnd, $LVM_DELETEALLITEMS) <> 0
EndFunc   ;==>_GUICtrlListView_DeleteAllItems

Func _SQLite_GetTable_self($hDB, $sSQL, ByRef $aResult, ByRef $iRows, ByRef $iColumns, $iCharSize = -1)
	$aResult = ''
	If __SQLite_hChk($hDB, 1) Then Return SetError(@error, 0, $SQLITE_MISUSE)
	If $iCharSize = "" Or $iCharSize < 1 Or $iCharSize = Default Then $iCharSize = -1
	; see comments in _SQLite_GetTable2d
	Local $hQuery
	Local $r = _SQLite_Query($hDB, $sSQL, $hQuery)
	If @error Then Return SetError(2, @error, $r)
	; we need column count and names
	Local $aDataRow
	$r = _SQLite_FetchNames($hQuery, $aDataRow)
	Local $err = @error
	If $err Then
		_SQLite_QueryFinalize($hQuery)
		Return SetError(3, $err, $r)
	EndIf
	$iColumns = UBound($aDataRow)
	Local Const $iRowsIncr = 64 ; initially allocate 64 datarows then grow by 4/3 of row count
	$iRows = 0 ; actual number of data rows
	Local $iAllocRows = $iRowsIncr ; number of allocated data rows
	Dim $aResult[($iAllocRows + 1) * $iColumns + 1]
	For $idx = 0 To $iColumns - 1
		If $iCharSize > 0 Then
			$aDataRow[$idx] = StringLeft($aDataRow[$idx], $iCharSize)
		EndIf
		$aResult[$idx + 1] = $aDataRow[$idx]
	Next
	$s=0
	While 1
		$r = _SQLite_FetchData($hQuery, $aDataRow, 0, 0, $iColumns)
		$err = @error
		Switch $r
			Case $SQLITE_OK
				$iRows += 1
				If $iRows = $iAllocRows Then
					$iAllocRows = Round($iAllocRows * 4 / 3)
					ReDim $aResult[($iAllocRows + 1) * $iColumns + 1]
				EndIf
				For $j = 0 To $iColumns - 1
					If $iCharSize > 0 Then
						$aDataRow[$j] = StringLeft($aDataRow[$j], $iCharSize)
					EndIf
					$idx += 1
					$aResult[$idx] = $aDataRow[$j]
				Next
				if $s<>int($iRows/100) then
					$s=($iRows/100)
					GUICtrlSetData($ProgressLabel1,$s*100)
				endif
			Case $SQLITE_DONE
				ExitLoop
			Case Else
				$aResult = ''
				_SQLite_QueryFinalize($hQuery)
				Return SetError(4, $err, $r)
		EndSwitch
	WEnd
	$aResult[0] = ($iRows + 1) * $iColumns
	ReDim $aResult[$aResult[0] + 1]
	GUICtrlSetData($WaitLabel_Progress,0)
	Return ($SQLITE_OK)
EndFunc   ;==>_SQLite_GetTable

Func _Mouse_Control_GetInfoAdlib($Files=-1)
	if $Files<>-1 then
		$pos1 = MouseGetPos()
		;If $pos1[0] <> $pos2[0] Or $pos1[1] <> $pos2[1] Then ; has the mouse moved?
			Local $a_info = _Mouse_Control_GetInfo()
			Local $aDLL = DllCall('User32.dll', 'int', 'GetDlgCtrlID', 'hwnd', $a_info[0]) ; get the ID of the control
			If @error Then Return
			$GuiWhnd=WinGetHandle("Bcherverwaltung")
			if _WinAPI_GetAncestor($appHandle, $GA_ROOT)<>$GuiWhnd then
				DoDropFiles(_WinAPI_GetAncestor($appHandle, $GA_ROOT), $Files,$aDLL[0])
			endif
			#cs
			ToolTip("Handle = " & $a_info[0] & @CRLF & _
					"Class = " & $a_info[1] & @CRLF & _
					"ID = " & $aDLL[0] & @CRLF & _
					"Mouse X Pos = " & $a_info[2] & @CRLF & _
					"Mouse Y Pos = " & $a_info[3] & @CRLF & _
					"ClassNN = " & $a_info[4] & @CRLF & _ ; optional
					"Parent Hwd = " & _WinAPI_GetAncestor($appHandle, $GA_ROOT))
			#ce
			;$pos2 = MouseGetPos()
		;EndIf
	else
		$pos1 = MouseGetPos()
		Local $a_info = _Mouse_Control_GetInfo()
		Local $aDLL = DllCall('User32.dll', 'int', 'GetDlgCtrlID', 'hwnd', $a_info[0]) ; get the ID of the control
		If @error Then Return
		$GuiWhnd=WinGetHandle("Bcherverwaltung")
		if _WinAPI_GetAncestor($appHandle, $GA_ROOT)=$GuiWhnd then
			return true
		endif
	endif
EndFunc   ;==>_Mouse_Control_GetInfoAdlib

Func _Mouse_Control_GetInfo()
    Local $client_mpos = $pos1 ; gets client coords because of "MouseCoordMode" = 2
    Local $a_mpos
;~  Call to removed due to offset issue $a_mpos = _ClientToScreen($appHandle, $client_mpos[0], $client_mpos[1]) ; $a_mpos now screen coords
    $a_mpos = $client_mpos
    $appHandle = GetHoveredHwnd($client_mpos[0], $client_mpos[1]) ; Uses the mouse to do the equivalent of WinGetHandle()

    If @error Then Return SetError(1, 0, 0)
    Local $a_wfp = DllCall("user32.dll", "hwnd", "WindowFromPoint", "long", $a_mpos[0], "long", $a_mpos[1]) ; gets the control handle
    If @error Then Return SetError(2, 0, 0)

    Local $t_class = DllStructCreate("char[260]")
    DllCall("User32.dll", "int", "GetClassName", "hwnd", $a_wfp[0], "ptr", DllStructGetPtr($t_class), "int", 260)
    Local $a_ret[5] = [$a_wfp[0], DllStructGetData($t_class, 1), $a_mpos[0], $a_mpos[1], "none"]
    Local $sClassNN = _ControlGetClassnameNN($a_ret[0]) ; optional, will run faster without it
    $a_ret[4] = $sClassNN

    Return $a_ret
EndFunc   ;==>_Mouse_Control_GetInfo

; ===============================================================================
; Retrieves the Handle of GUI/Application the mouse is over.
; Similar to WinGetHandle except it used the current mouse position
; Taken from <a href='http://www.autoitscript.com/forum/index.php?showtopic=444962' class='bbc_url' title=''>http://www.autoitscript.com/forum/index.php?showtopic=444962</a>
; Changed to take params to allow only one set of coords to be used.
; Params
;~  $i_xpos - x position of the mouse - usually from MouseGetPos(0)
;~  $i_ypos - x position of the mouse - usually from MouseGetPos(1)
; ===============================================================================
Func GetHoveredHwnd($i_xpos, $i_ypos)
    Local $iRet = DllCall("user32.dll", "int", "WindowFromPoint", "long", $i_xpos, "long", $i_ypos)
    If IsArray($iRet) Then
        $appHandle = $iRet[0]
        Return HWnd($iRet[0])
    Else
        Return SetError(1, 0, 0)
    EndIf
EndFunc   ;==>GetHoveredHwnd

; ===============================================================================
;~ Gets the ClassNN of a control (Classname and Instance Count). This is checked with ControlGetHandle
;~ The instance is really a way to uniquely identify classes with the same name
;~ Big thanks to Valik for writing the function, taken from - <a href='http://www.autoitscript.com/forum/index.php?showtopic=97662' class='bbc_url' title=''>http://www.autoitscript.com/forum/index.php?showtopic=97662</a>
;~ Param
;~  $hControl - the control handle from which you want the ClassNN
;~ Returns
;~  the ClassNN of the given control

; ===============================================================================
Func _ControlGetClassnameNN($hControl)
    If Not IsHWnd($hControl) Then Return SetError(1, 0, "")
    Local Const $hParent = _WinAPI_GetAncestor($appHandle, $GA_ROOT) ; get the Window handle, this is set in GetHoveredHwnd()
    If Not $hParent Then Return SetError(2, 0, "")

    Local Const $sList = WinGetClassList($hParent) ; list of every class in the Window
    Local $aList = StringSplit(StringTrimRight($sList, 1), @LF, 2)
    _ArraySort($aList) ; improves speed
    Local $nInstance, $sLastClass, $sComposite

    For $i = 0 To UBound($aList) - 1
        If $sLastClass <> $aList[$i] Then ; set up the first occurrence of a unique classname
            $sLastClass = $aList[$i]
            $nInstance = 1
        EndIf
        $sComposite = $sLastClass & $nInstance ;build the ClassNN for testing with ControlGetHandle. ClassNN = Class & ClassCount
        ;if ControlGetHandle(ClassNN) matches the given control return else look at the next instance of the classname
        If ControlGetHandle($hParent, "", $sComposite) = $hControl Then
            Return $sComposite
        EndIf
        $nInstance += 1 ; count the number of times the class name appears in the list
    Next
    Return SetError(3, 0, "")

EndFunc   ;==>_ControlGetClassnameNN

#cs
Func DoDropFiles($wnd, $Files,$cID)
	if _GUICtrlListView_GetSelectionMark (GUICtrlGetHandle($MainGui_MainListView))<>-1 then
		;msgbox(48,"",$wnd&"|:|"&$Files&"|:|"&$cID)
		;$wnd is the handle of the control we are dropping onto
		;$Files is the list of files separated by "|"
	    $tagStruct1 = "int offset;int px;int py;byte fNC;byte fWide"

		;grab some memory
		 $hGlobal = _MemGlobalAlloc(14 + StringLen($Files) + 2)
		;DropFiles := GlobalLock(MemHandle)
		;translates the memory handle to a pointer
		 $pDropFiles = _MemGlobalLock($hGlobal)
		;create the struct in this memory
		 $ar=WinGetPos($wnd)
		 $DropFiles = DllStructCreate($tagStruct1 & ";char  filelist[" & StringLen($Files) + 2 & "]", $pDropFiles)
		 DllStructSetData($DropFiles, "offset", 14);14 = int+int+int+byte+byte
		 $dummy = 0; done its job
		 DllStructSetData($DropFiles, "px", $pos1[0]-$ar[0]);tried setting a point inside Notepad
		 DllStructSetData($DropFiles, "py", $pos1[1]-$ar[1]);but it makes no difference
		 DllStructSetData($DropFiles, "fwide", 0)
		 DllStructSetData($DropFiles, "fNC", 0)
		 DllStructSetData($DropFiles, "filelist", $Files)
		;set the nulls in place of the separaters
		 $Size = 0;
		 $Files = StringSplit($Files, "|")
		 For $I = 1 To $Files[0]

	    ;// number of characters per string (as ANSI) plus one #0 terminator
	    ;Inc(Size, Length(Files[I]) + 1);
			 $Size += StringLen($Files[$I]) + 1
			 DllStructSetData($DropFiles, "filelist", 0, $Size)
		 Next
		 ;ConsoleWrite(DllStructGetData($DropFiles, "filelist") & @CRLF)
		;now add the extra null to terminate the list of strings
		 DllStructSetData($DropFiles, "filelist", 0, $Size + 1)
		 _MemGlobalUnlock($hGlobal)
		 ;_WinAPI_PostMessage($wnd, $WM_DROPFILES, $hGlobal, 0);
		 _WinAPI_PostMessage($wnd, $WM_DROPFILES, $hGlobal, 0)
		;// ... and finally release the memory

		 _MemGlobalFree($hGlobal)
	EndIF
 EndFunc;==>DoDropFiles
 #ce

 Func DoDropFiles($wnd, $Files)
    Local $tagStruct1, $dummy, $hGlobal, $pDropFiles, $DropFiles, $Size
    ;$wnd is the handle of the control we are dropping onto
    ;$Files is the list of files separated by "|"
    $tagStruct1 = "int offset;int px;int py;wchar fNC;wchar fWide"
    $dummy = DllStructCreate($tagStruct1)

    ;grab some memory
    $hGlobal = _MemGlobalAlloc(DllStructGetSize($dummy) + StringLen($Files) + 2)
    ;DropFiles := GlobalLock(MemHandle)
    ;translates the memory handle to a pointer
    $pDropFiles = _MemGlobalLock($hGlobal)
    ;create the struct in this memory
    $DropFiles = DllStructCreate($tagStruct1 & ";char  filelist[" & StringLen($Files) + 2 & "]", $pDropFiles)
    DllStructSetData($DropFiles, "offset", DllStructGetSize($dummy))
    $dummy = 0; done its job
    DllStructSetData($DropFiles, "px", 0);tried setting a point inside Notepad
    DllStructSetData($DropFiles, "py", 0);but it makes no difference
    DllStructSetData($DropFiles, "fwide", 0)
    DllStructSetData($DropFiles, "fNC", 0)
    DllStructSetData($DropFiles, "filelist", $Files)
    ;set the nulls in place of the separaters
    $Size = 0;
    $Files = StringSplit($Files, "|")
    For $I = 1 To $Files[0]

        ;// number of characters per string (as ANSI) plus one #0 terminator
        ;Inc(Size, Length(Files[I]) + 1);
        $Size += StringLen($Files[$I]) + 1
        DllStructSetData($DropFiles, "filelist", 0, $Size)
    Next
    ;ConsoleWrite(DllStructGetData($DropFiles, "filelist") & @CRLF)
    ;now add the extra null to terminate the list of strings
    DllStructSetData($DropFiles, "filelist", 0, $Size + 1)
    _MemGlobalUnlock($hGlobal)
    _WinAPI_PostMessage($wnd, $WM_DROPFILES, $hGlobal, 0);
    ;// ... and finally release the memory

    _MemGlobalFree($hGlobal)
EndFunc   ;==>DoDropFiles

Func _WinInfoFromPoint($nX, $nY);by Saio
    Local $tStrBuff, $pStrBuff, $aRet, $hWnd, $hOwnerWnd, $sClassName, $sOwnerClass, $sWinText
    $tStrBuff = DllStructCreate("char[100]")
    $pStrBuff = DllStructGetPtr($tStrBuff)
    $aRet = DllCall("user32.dll", "hwnd", "WindowFromPoint", "uint", $nX, "uint", $nY)
    $hWnd = $aRet[0]
    $aRet = DllCall("user32.dll", "int", "GetClassName", "hwnd", $hWnd, "ptr", $pStrBuff, "int", 100)
    $sClassName = DllStructGetData($tStrBuff, 1)
    DllStructSetData($tStrBuff, 1, "")
    DllCall("user32.dll", "int", "GetWindowText", "hwnd", $hWnd, "ptr", $pStrBuff, "int", 100)
;~  DllCall("user32.dll", "int", "SendMessage", "hwnd", $hWnd, "uint", $WM_GETTEXT, "uint", 100, "ptr", $pStrBuff)
    $sWinText = DllStructGetData($tStrBuff, 1)
    DllStructSetData($tStrBuff, 1, "")
    $aRet = DllCall("user32.dll", "hwnd", "GetAncestor", "hwnd", $hWnd, "uint", 2);$GA_ROOT = 2
    $hOwnerWnd = $aRet[0]
    $aRet = DllCall("user32.dll", "int", "GetClassName", "hwnd", $hOwnerWnd, "ptr", $pStrBuff, "int", 100)
    $sOwnerClass = DllStructGetData($tStrBuff, 1)
    DllStructSetData($tStrBuff, 1, "")

    Local $Array[5] = [$sWinText, $sClassName, $hWnd, $sOwnerClass, $hOwnerWnd]

    ;Window Text: $sWinText | $Array[0]
    ;ClassName: $sClassName | $Array[1]
    ;Window Handle: $hWnd | $Array[2]
    ;Owner ClassName: $sOwnerClass | $Array[3]
    ;Owner Handle: $hOwnerWnd | $Array[4]
	#cs
    ConsoleWrite(@CRLF & "{ WinInfo }" & @CRLF)
    ConsoleWrite("Window Text: " & $sWinText & @CRLF)
    ConsoleWrite("ClassName: " & $sClassName & @CRLF)
    ConsoleWrite("Window Handle: " & $hWnd & @CRLF)
    ConsoleWrite("Owner ClassName: " & $sOwnerClass & @CRLF)
    ConsoleWrite("Owner Handle: " & $hOwnerWnd & @CRLF)
    ConsoleWrite("{ WinInfo }" & @CRLF & @CRLF)
	#ce
    Return $Array

EndFunc   ;==>_WinInfoFromPoint

Func sqlkonsole()
   $SqlGui=guicreate("SQL-Konsole",800,600,0,0,$WS_CAPTION +$WS_SYSMENU+ $WS_SIZEBOX+$WS_MINIMIZEBOX+$WS_MAXIMIZEBOX,-1,$MainGui);$WS_POPUP; +$WS_MINIMIZEBOX+$WS_MAXIMIZEBOX,$WS_EX_ACCEPTFILES)
   GUISetOnEvent($GUI_EVENT_CLOSE, "closeSqlGui")
   $SqlGui_handle = wingethandle($SqlGui)
   $SqlGui_size=WinGetClientSize($SqlGui_handle)
   $SqlGui_Edit3_1=guictrlcreateedit("#Alles hinter der # wird als Kommentar gewertet"&@crlf&"#select * from Buecher where id<100 #Buechertabelle anzeigen"&@crlf&"#delete from Buecher where id=-1 #Buch lschen"&@crlf&"#INSERT INTO Buecher(id) VALUES (29) #Buch eintragen (Fr Werte siehe Select)"&@crlf&"#UPDATE Buecher SET id = '-1' WHERE id='-1' #Eintrag ndern"&@crlf,10,10,380,540)
   GUICtrlSetResizing ( -1, 2)
   $SqlGui_ListView3_1=guictrlcreatelistview("",400,10,$SqlGui_size[0]-410,$SqlGui_size[1]-20)
   GUICtrlSetResizing ( -1, 4)
   $SqlGui_Button3_1=guictrlcreatebutton("absenden",10,560, 100)
   GUICtrlSetResizing ( -1, 768+2)
   guictrlsetonevent(-1,"sqlsend")
   $SqlGui_Button3_2=guictrlcreatebutton("schlieen",120,560,100)
   GUICtrlSetResizing ( -1, 768+2)
   guictrlsetonevent(-1,"closeSqlGui")
   guisetstate(@sw_show,$SqlGui)
   ;_SQLite_Exec($DBN, "DELETE FROM filmgenre WHERE fg.id =(select filme where id='')")
EndFunc

Func closeSqlGui()
	GUIDelete($SqlGui)
EndFunc

Func sqlsend()
   $x=stringsplit(guictrlread($SqlGui_Edit3_1),@crlf)
   for $a=1 to ubound($x)-1 step +1
	  if stringinstr($x[$a],"#")=1 Then
		 ;nichts
	  else
		 if stringinstr($x[$a],"#")>1 Then
			$strs=stringsplit($x[$a],"#")
			$x[$a]=$strs[1]
		 endif
		 if stringinstr($x[$a],"select")>0 Then
			;msgbox(48,"test","select")
			;_arraydisplay($aData)
			;guictrldelete($SqlGui_ListView3_1)
			_GUICtrlListView_DeleteAllItems($SqlGui_ListView3_1)
			local $aData,$iRow,$iClumn
			_SQLite_GetTable($hDatabase, $x[$a],$aData, $iRow, $iClumn)
			for $i=0 to _GUICtrlListView_GetColumnCount($SqlGui_ListView3_1)+1 step 1
				_GUICtrlListView_DeleteColumn($SqlGui_ListView3_1,0)
			next
			;_GUICtrlListView_DeleteAllItems($ListView3_1)
			;guictrlsetdata($ListView3_1," | | | | | | |")
			for $g=1 to ubound($aData)-1 step $iClumn
			   ;msgbox(48,"test",$g)
			   if $g=1 Then
				  $string=""
				  for $h=0 to $iClumn-1 step 1
					 ;msgbox(48,"test","1:"&$h)
					 _GUICtrlListView_AddColumn($SqlGui_ListView3_1,$aData[$g+$h])
				  next
				  ;msgbox(48,"test",$string)
				  ;$SqlGui_ListView3_1=guictrlcreatelistview($string,400,10,$SqlGui_size[0]-410,$SqlGui_size[1]-20)
			   Else
				  $string=""
				  for $h=0 to $iClumn-1 step 1
					 ;msgbox(48,"test","2:"&$h)
					 if $h=0 Then
						$string&=$aData[$g+$h]
					 else
						$string&="|"&$aData[$g+$h]
					 endif
				  next
				  ;msgbox(48,"test",$string)
				  guictrlcreatelistviewitem($string,$SqlGui_ListView3_1)
			   endif
			next
		 else
			;msgbox(48,"test","other")
			_SQLite_Exec($hDatabase,$x[$a])
		 endif
	  endif
   next
   ;msgbox(48,"Hinweis","Befehle erfolgreich abgesendet!")
EndFunc